/*
 * AutoM.cs
 */
using System;

namespace Beringer.oopBuch.EinfacheBsp
{
    /**
    <summary>
    Model-Klasse für Testzwecke mit Trivialmethode 'Ausgeben' und mit 
    Initialisierungen von Attributen (insbesondere des Auto-Besitzers).

    <p>
    Seit: August 2005 <br />
    Version: Juli 2012 (PKW-Klasse umbenennen auf 'Auto'.
                        Initialisierung des Besitzers im Konstruktor.)
    </p>

    <seealso cref="Auto" />
    <seealso cref="Beringer.oopBuch.GUI.MusterfensterV" />
    <seealso cref="Beringer.oopBuch.GUI.FensterMenuV" />
    <seealso cref="Beringer.oopBuch.GUI.DialogModalElternfensterV" />
    <seealso cref="Beringer.oopBuch.GUI.DialogModalKindfensterV" />

    Autor: Beringer Alfred
    </summary>
    <remarks>
    Diese Klasse dient nur als Fachobjekt ("model") für die
    GUI-Beispiele 'Musterfenster', 'FensterMenu' und den 'Dialog'-Klassen.
    </remarks>
    */
    public class AutoM : Auto
    {
        // -------------------------------------------------------------------------
        // Konstruktoren
        // -------------------------------------------------------------------------

        public AutoM()
        {
            MwstSatz(20);
            Farbe = "blau";
            Besitzer = new Person(1980, Person.MAENNLICH);
            Besitzer.AendernVorname("Hugo");
        }

        // -------------------------------------------------------------------------
        // Neue Instanzmethoden
        // -------------------------------------------------------------------------

        /**
        <summary>
        Ausgabe eines übergebenen Textes auf die Standardausgabe.
        </summary>

        <param name="s">
          auszugebender Text
        </param>
        */
        public void Ausgeben(String s)
        {
            Console.WriteLine(s);
        }
    }
}
