/*
 * AutoTesten.cs
 */
using System;

namespace Beringer.oopBuch.EinfacheBsp
{
    /**
    <summary>
    Applikation zum Testen der Klasse 'Auto'.

    <p>
    Seit: November 2004 <br />
    Version: Juli 2012 (PKW-Klasse umbenennen auf 'Auto')
    </p>

    <seealso cref="Auto" />
    <seealso cref="Beringer.oopBuch.EinfacheBspProgramme.ProgrammAutoTesten"/>

    Autor: Beringer Alfred
    </summary>
    */
    public class AutoTesten
    {
        /** --------------------------------------------------------------------
        <summary>
        Start-Methode zum Testen der Applikation.
        </summary>
        */
        public void Start()
        {
            Auto  herbie;                // Referenz für Auto-Instanz definieren

            herbie = new Auto();         // Auto-Instanz erzeugen

            herbie.Besitzer = new Person(1980, 'M');
            herbie.Farbe = "blau";       // Farbe ändern
            herbie.Raufschalten();       // 2. Gang
            herbie.ZeigeInhalt();  

            Auto.MwstSatz(20);           // Mehrwertsteuersatz ändern
            herbie.Besitzer.AendernVorname("Hugo");   // Vorname Besitzer ändern
            herbie.Raufschalten();       // 3. Gang
            herbie.Raufschalten();       // 4. Gang
            herbie.ZeigeInhalt();

            herbie.Runterschalten();     // 3. Gang
            herbie.Beschleunigen();
            herbie.ZeigeInhalt();

            herbie.Bremsen();
            herbie.ZeigeInhalt();

            Console.WriteLine(
                    "--------------------------------------------------------");
            Console.WriteLine(
                    "Auto-Daten mit Hilfe der Methode 'ToString()' anschauen:");
            Console.WriteLine(herbie);

#if DEBUG
            Console.ReadLine();
#endif
        }
    }
}
