/*
 * ParameterTesten.cs
 */
using System;

namespace Beringer.oopBuch.EinfacheBsp
{
    /**
    <summary>
    Applikation zum Testen der Parameterübergabe mit Call By Reference.

    <p>
    Seit: Mai 2013
    </p>

    <seealso cref="Person" />
    <seealso 
          cref="Beringer.oopBuch.EinfacheBspProgramme.ProgrammParameterTesten"/>

    Autor: Beringer Alfred
    </summary>
    */
    public class ParameterTesten
    {
        /** --------------------------------------------------------------------
        <summary>
        Start-Methode zum Testen der Applikation.
        </summary>
        */
        public void Start()
        {
            Person  p = new Person(1980, 'M');
            p.AendernVorname("Hugo");

            Testen(ref p);
            Console.WriteLine("Danach jetzt doch: " + p.Heisst());

#if DEBUG
            Console.ReadLine();
#endif
        }

        /** --------------------------------------------------------------------
        </summary>
        Methode mit 1 Parameter - dieser Parameter ist ein Referenztyp.
        Die Adresse des Arguments wird beim Aufruf der Methode an die 
        Methode übergeben (call by reference!). Daher ist der Parameter 'param' 
        identisch mit dem Argument. D.h.: Wird der Parameter geändert, so wird 
        gleichzeitig das Argument geändert. Wird die Bindung des Parameters an 
        das 'Person'-Objekt in der Methode aufgehoben, ist automatisch auch die 
        Bindung des Arguments aufgehoben!!!
        </summary>

        <param name="param">
          Referenz auf ein 'Person'-Objekt
        </param>
        */
        public void Testen(ref Person param)
        {
            Person  pp = new Person(2013, 'M');
            pp.AendernVorname("Maxi");

            param = pp;                            // Originalreferenz geändert!
            Console.WriteLine("   In der Methode: " + param.Heisst());
        }
    }
}
