/*
 * Zaehler3.cs
 */

namespace Beringer.oopBuch.EinfacheBsp
{
    /**
    <summary>
    Beispielklasse für Vererbung - entspricht der Klasse 'Zaehler2'.

    <p>
    Seit: November 2004
    </p>

    <seealso cref="Zaehler" />
    <seealso cref="Zaehler2" />
    <seealso cref="Zaehler3Testen" />

    Autor: Beringer Alfred
    </summary>
    <remarks>
    Erweiterung der Klasse 'Zaehler' mit einem Klassenattribut für den Endwert.
    </remarks>
    */
    public class Zaehler3 : Zaehler
    {
        // ---------------------------------------------------------------------
        // Klassenattribute
        // ---------------------------------------------------------------------

        /**
        <summary>
        Der größte Wert, den der Zähler annehmen kann, danach muss der Zähler
        zurückgesetzt werden.
        </summary>
        */
        private static int  endwert = 99;

        // ---------------------------------------------------------------------
        // Überschriebene Instanzmethoden
        // ---------------------------------------------------------------------

        /**
        <summary>
        Überschreibt die entsprechende Zaehler-Methode. <br />
        Der neue Zählerwert wird nun auf Plausibilität geprüft!
        </summary>

        <param name="value">
          neuer Zählerwert, der zwischen 0 und Endwert liegen muss
        </param>
        */
        override protected void setWert(int value)
        {
            base.setWert(value);                      // Aufruf der Basismethode
            if ( (Wert > Endwert()) || (Wert < 0) )
            {
                Reset();
            }
        }

        // ---------------------------------------------------------------------
        // Klassenmethoden
        // ---------------------------------------------------------------------

        /**
        <summary>
        Liefert den aktuellen Endwert für den Zähler.
        </summary>

        <returns>
          aktueller Endwert
        </returns>
        */
        public static int Endwert()
        {
            return  endwert;
        }

        // ---------------------------------------------------------------------

        /**
        <summary>
        Definiert einen neuen Endwert für den Zähler - es erfolgt jedoch keine 
        Prüfung auf Plausibilität!
        </summary>

        <param name="value">
          neuer (beliebiger) Endwert
        </param>
        */
        public static void Endwert(int value)
        {
            endwert = value;
        }
    }
}
