/*
 * BorderLayoutV.cs
 */
using System;
using System.Windows.Forms;
using System.Drawing;

namespace Beringer.oopBuch.GUI
{
    /**
    <summary>
    Hauptfenster für Simulierung eines BorderLayouts mit Hilfe der 
    Property 'Dock' (ohne Ereignisse).

    <p>
    Seit: August 2005
    </p>

    Autor: Beringer Alfred
    </summary>
    */
    public class BorderLayoutV : Form
    {
        // ---------------------------------------------------------------------
        // Instanzattribute
        // ---------------------------------------------------------------------

        private Button  b1 = new Button();
        private Button  b2 = new Button();
        private Button  b3 = new Button();
        private Button  b4 = new Button();
        private Button  b5 = new Button();

        // ---------------------------------------------------------------------
        // Konstruktoren
        // ---------------------------------------------------------------------

        /**
        <summary>
        Standardkonstruktor.
        </summary>
        */
        public BorderLayoutV()
        {
            this.Text = "Fenster mit BorderLayout";
            this.Size = new Size(400, 260);

            b1.Text = "Norden";
            b2.Text = "Süden";
            b3.Text = "Westen";
            b4.Text = "Osten";
            b5.Text = "Zentrum";

            // GUI-Komponenten in der Windows-Form platzieren 

            b1.Dock = DockStyle.Top;
            b2.Dock = DockStyle.Bottom;
            b3.Dock = DockStyle.Left;
            b4.Dock = DockStyle.Right;
            b5.Dock = DockStyle.Fill;

            // GUI-Komponenten der Windows-Form hinzufügen

            this.Controls.Add(b5);
                               /* 
                                 Reihenfolge wesentlich - zuerst das Zentrum!
                                 Jede nachfolgend eingefügte Komponente nimmt 
                                 Platz von vorher eingefügten Komponenten weg.
                                        
                                 Allgemeine Regel: von innen nach außen!
                                */
            this.Controls.Add(b3);
            this.Controls.Add(b4);
            this.Controls.Add(b1);
            this.Controls.Add(b2);
        }
    }
}
