/*
 * Hauptfenster2.cs
 */
using System;
using System.Windows.Forms;
using System.Drawing;

namespace Beringer.oopBuch.GUI
{
    /**
    <summary>
    Einfaches Fenster mit Ereigniswächter für Einfach-Klick 
    (MessageBox zeigen).

    <p>
    Seit: August 2005
    </p>

    <seealso cref="Hauptfenster1" />

    Autor: Beringer Alfred
    </summary>
    */
    public class Hauptfenster2 : Form
    {
        // ---------------------------------------------------------------------
        // Konstruktoren
        // ---------------------------------------------------------------------

        /**
        <summary>
        Standardkonstruktor.
        </summary>
        */
        public Hauptfenster2()
        {
            this.Text = "Hauptfenster2 - Einfach-Klick";
            this.Size = new Size(400, 260);

            // GUI-Komponenten bei Ereigniswächter anmelden

            this.Click += new EventHandler(klicken);
        }

        // *********************************************************************
        // Ereignisbehandlungsmethoden
        // *********************************************************************

        /**
        <summary>
        Methode für "Maus klicken".
        </summary>
        <remarks>
        Entspricht in Java einer API-Methode.
        </remarks>

        <param name="sender">
          Ereignisquelle
        </param>
        <param name="e">
          Ereignisobjekt (enthält Informationen über das Ereignis)
        </param>
        */
        private void klicken(Object sender, EventArgs e)
        {
            MessageBox.Show(this,
                            "Maus wurde im Fenster 1-mal gedrückt.",
                            "Info für Hauptfenster2",
                            MessageBoxButtons.OK,
                            MessageBoxIcon.Information);
        }
    }
}
