/*
 * Standardfenster11V.cs
 */
using System;
using System.Windows.Forms;
using System.Drawing;

namespace Beringer.oopBuch.GUI
{
    /**
    <summary>
    Einfaches Hauptfenster mit Menüzeile (ohne Ereignisse).

    <p>
    Seit: August 2005
    </p>

    <seealso cref="StandardfensterV" />
    <seealso cref="FensterMenuV" />

    Autor: Beringer Alfred
    </summary>
    <remarks>
    Version für .NET 1.1 (Menüsystem mit der Hauptklasse 'MainMenu').
    </remarks>
    */
    public class Standardfenster11V : Form
    {
        // ---------------------------------------------------------------------
        // Instanzattribute
        // ---------------------------------------------------------------------

        private MainMenu  menuezeile  = new MainMenu();

        private MenuItem  menue1       = new MenuItem("Menü1");
        private MenuItem  menueItem11  = new MenuItem("1. Menüeintrag Menü1");
        private MenuItem  menueItem12  = new MenuItem("2. Menüeintrag Menü1");
        private MenuItem  menueItem13  = new MenuItem("...");

        private MenuItem  menue2       = new MenuItem("Menü2");
        private MenuItem  menueItem21  = new MenuItem("1. Menüeintrag Menü2");
        private MenuItem  checkItem22  = new MenuItem("2. Check-Menüeintrag Menü2");
        private MenuItem  checkItem23  = new MenuItem("3. Check-Menüeintrag Menü2");
        private MenuItem  menue24      = new MenuItem("4. Untermenü Menü2");

        private MenuItem  menueItem241 = new MenuItem("1. Menüeintrag Untermenü24");
        private MenuItem  menueItem242 = new MenuItem("2. Menüeintrag Untermenü24");

        private MenuItem  radioItem25  = new MenuItem("5. Radio-Menüeintrag Menü2");
        private MenuItem  radioItem26  = new MenuItem("6. Radio-Menüeintrag Menü2");
        private MenuItem  radioItem27  = new MenuItem("7. Radio-Menüeintrag Menü2");
        private MenuItem  menueItem28  = new MenuItem("...");

        private MenuItem  menue3       = new MenuItem("...");
        private MenuItem  menueItem31  = new MenuItem("...");

        // ---------------------------------------------------------------------
        // Konstruktoren
        // ---------------------------------------------------------------------

        /**
        <summary>
        Standardkonstruktor.
        </summary>
        <remarks>
        Das Erzeugen der Menüzeile wird in eine private Methode ausgelagert.
        </remarks>
        */
        public Standardfenster11V()
        {
            this.Text = "Standardfenster mit Menüzeile 1.1";
            this.Size = new Size(400, 260);

            menuezeileErstellen();

            // Menüzeile für Windows-Form definieren
            
            this.Menu = menuezeile;
        }

        // ---------------------------------------------------------------------
        // private Instanzmethoden
        // ---------------------------------------------------------------------

        /**
        <summary>
        Erzeugen der Menüzeile.
        </summary>
        */
        private void menuezeileErstellen()
        {
            // Menüpunkte in Menüs einfügen

            menue1.MenuItems.Add(menueItem11);                
            menue1.MenuItems.Add(menueItem12);
            menue1.MenuItems.Add(menueItem13);

            menue2.MenuItems.Add(menueItem21);
            menue2.MenuItems.Add(checkItem22);
            menue2.MenuItems.Add(checkItem23);
            menue2.MenuItems.Add(menue24);  // Untermenü24 als Menüpunkt einfügen
            menue2.MenuItems.Add(radioItem25);
            menue2.MenuItems.Add(radioItem26);
            menue2.MenuItems.Add(radioItem27);
            menue2.MenuItems.Add(menueItem28);

            menue3.MenuItems.Add(menueItem31);

            // Menüpunkte in Untermenüs einfügen

            menue24.MenuItems.Add(menueItem241);              
            menue24.MenuItems.Add(menueItem242);

            // Menüs in Menüzeile einfügen

            menuezeile.MenuItems.Add(menue1);                 
            menuezeile.MenuItems.Add(menue2);
            menuezeile.MenuItems.Add(menue3);

            // Initialisierung der true-Checkbox-Menüeinträge

            checkItem22.Checked = true;

            // Hakerl durch Radiobutton-Punkt ersetzen

            radioItem25.RadioCheck = true;
            radioItem26.RadioCheck = true;
            radioItem27.RadioCheck = true;

            // Initialisierung des (einzigen) true-Radiobutton-Menüeintrags

            radioItem26.Checked = true;
        }
    }
}
