/*
 * Abteilung.cs
 */

namespace Beringer.oopBuch.Organisation
{
    /**
    <summary>
    Instanzen dieser Klasse repräsentieren Abteilungen einer Organisation.
    <p>
    Seit: November 2004
    </p>

    <seealso cref="Organisation" />
    <seealso cref="OrganisationTesten" />

    Autor: Beringer Alfred
    </summary>
    */
    public class Abteilung : Organisation
    {
        // ---------------------------------------------------------------------
        // Instanzattribute
        // ---------------------------------------------------------------------

        private float  einnahmen = 0.0f;

        // ---------------------------------------------------------------------
        // Properties
        // ---------------------------------------------------------------------

        /**
        <summary>
        Property für die Einnahmen der Abteilung.
        </summary>
        */
        public float Einnahmen
        {
            get
            {
                return einnahmen;
            }
            set
            {
                einnahmen = value;
            }
        }

        // ---------------------------------------------------------------------
        // Instanzmethoden
        // ---------------------------------------------------------------------

        /**
        <summary>
        Erhöht die Einnahmen der Abteilung.
        </summary>
        <param name="einnahmen">
          Wert, der zu den Einnahmen addiert wird
        </param>
        */
        public void AddiereZuEinnahmen(float einnahmen)
        {
            this.einnahmen += einnahmen;
        }

        /**
        <summary>
        Berechnet den Gewinn der Abteilung.

        <seealso cref="Organisation.GewinnOhnePraemie()" />
        <seealso cref="Projekt.GewinnOhnePraemie()" />

        </summary>
        <returns>
          Einnahmen - Gesamtkosten ohne Prämie
        </returns>
        */
        override public float GewinnOhnePraemie()
        {
            return  Einnahmen - GesamtkostenOhnePraemie();
        }
    }
}
