/*
 * Kunde.cs
 */
using System;

namespace Beringer.oopBuch.Organisation
{
    /**
    <summary>
    Instanzen dieser Klasse repräsentieren Kunden.
    <p>
    Seit: November 2004
    </p>

    <seealso cref="Person" />

    Autor: Beringer Alfred
    </summary>
    */
    public class Kunde : Person
    {
        // ---------------------------------------------------------------------
        // Instanzattribute
        // ---------------------------------------------------------------------

        private float  jahresumsatz = 0.0f;
        private float  kreditlimit = 0.0f;

        // ---------------------------------------------------------------------
        // Konstruktoren
        // ---------------------------------------------------------------------

        /**
        <summary>
        Konstruktor.

        <seealso cref="Person.Person(String, DateTime, char, String)" />

        </summary>
        <param name="name">
          Name
        </param>
        <param name="geburtsdatum">
          Geburtsdatum
        </param>
        <param name="geschlecht">
          Geschlecht
        </param>
        <param name="adresse">
          Adresse
        </param>
        */
        public Kunde(String    name,
                     DateTime  geburtsdatum,
                     char      geschlecht,
                     String    adresse)
            : base(name, geburtsdatum, geschlecht, adresse)
        {
        }

        /**
        <summary>
        Konstruktor.

        <seealso cref="Person.Person(String, DateTime, char)" />

        </summary>
        <param name="name">
          Name
        </param>
        <param name="geburtsdatum">
          Geburtsdatum
        </param>
        <param name="geschlecht">
          Geschlecht
        </param>
        */
        public Kunde(String name, DateTime geburtsdatum, char geschlecht)
            : this(name, geburtsdatum, geschlecht, "")
        {
        }

        /**
        <summary>
        Konstruktor.

        <seealso cref="Person.Person(DateTime, char)" />

        </summary>
        <param name="geburtsdatum">
          Geburtsdatum
        </param>
        <param name="geschlecht">
          Geschlecht
        </param>
        */
        public Kunde(DateTime geburtsdatum, char geschlecht)
            : this("", geburtsdatum, geschlecht, "")
        {
        }

        // ---------------------------------------------------------------------
        // Properties
        // ---------------------------------------------------------------------

        /**
        <summary>
        Property für den Jahresumsatz des Kunden.
        </summary>
        */
        public float Jahresumsatz
        {
            get
            {
                return jahresumsatz;
            }
            set
            {
                jahresumsatz = value;
            }
        }

        /**
        <summary>
        Property für das Kreditlimit des Kunden.
        </summary>
        */
        public float Kreditlimit
        {
            get
            {
                return kreditlimit;
            }
            set
            {
                kreditlimit = value;
            }
        }
    }
}
