/*
 * Projekt.cs
 */

namespace Beringer.oopBuch.Organisation
{
    /**
    <summary>
    Instanzen dieser Klasse repräsentieren Projekte einer Organisation.
    <p>
    Seit: November 2004
    </p>

    <seealso cref="Organisation" />
    <seealso cref="OrganisationTesten" />

    Autor: Beringer Alfred
    </summary>
    */
    public class Projekt : Organisation
    {
        // ---------------------------------------------------------------------
        // Instanzattribute
        // ---------------------------------------------------------------------

        private int    planZeit = 1;
        private float  planJahresgewinn = 0.0f;
        private int    planLebensdauer = 0;

        // ---------------------------------------------------------------------
        // Properties
        // ---------------------------------------------------------------------

        /**
        <summary>
        Property für die geplante Zeit des Projekts in Jahren.
        </summary>
        */
        public int PlanZeit
        {
            get
            {
                return planZeit;
            }
            set
            {
                planZeit = value;
            }
        }

        /**
        <summary>
        Property für den geplanten Jahresgewinn des Projekts.
        </summary>
        */
        public float PlanJahresgewinn
        {
            get
            {
                return planJahresgewinn;
            }
            set
            {
                planJahresgewinn = value;
            }
        }

        /**
        <summary>
        Property für die geplante Lebensdauer des Projekts in Jahren.
        </summary>
        */
        public int PlanLebensdauer
        {
            get
            {
                return planLebensdauer;
            }
            set
            {
                planLebensdauer = value;
            }
        }

        // ---------------------------------------------------------------------
        // Instanzmethoden
        // ---------------------------------------------------------------------

        /**
        <summary>
        Berechnet den Gewinn des Projekts.

        <seealso cref="Organisation.GewinnOhnePraemie()" />
        <seealso cref="Abteilung.GewinnOhnePraemie()" />

        </summary>
        <returns>
          Projektgewinn - Gesamtkosten ohne Prämie
        </returns>
        */
        override public float GewinnOhnePraemie()
        {
            return  (planJahresgewinn * planLebensdauer)
                        / (planZeit * 12) - GesamtkostenOhnePraemie() ;
        }
    }
}
