#include "stdafx.h"
#include <string.h>
#include <time.h>
#include <iostream>

#include "PersonOrganisation.h"

using namespace std;

#define MAXANZAHL 100

// ******************************************************************

char Datum::Monatsnamen [12][9+1] = { "Jnner   ",
                                      "Februar  ",
                                      "Mrz     ",
                                      "April    ",
                                      "Mai      ",
                                      "Juni     ",
                                      "Juli     ",
                                      "August   ",
                                      "September",
                                      "Oktober  ",
                                      "November ",
                                      "Dezember " };

int Datum::TageProMonat [12]       = { 31,  28,  31,  30,  31,  30,  31,  31,  30,  31,  30,  31 };

int Datum::LfdTagMonatsanfang [12] = {  1,  32,  60,  91, 121, 152, 182, 213, 244, 274, 305, 335 };

Datum::Datum()                  // Standardkonstruktor
{
  time_t ltime;
  struct tm *today;
  
  time(&ltime);
  today = localtime(&ltime);

  tt = today->tm_mday;
  mm = today->tm_mon + 1;
  jj = today->tm_year + 1900;
}

Datum::Datum(int tag, int monat, int jahr)
{
  time_t ltime;
  struct tm *today;
  
  time(&ltime);
  today = localtime(&ltime);

  tt = today->tm_mday;
  mm = today->tm_mon + 1;
  jj = today->tm_year + 1900;

  // ----------------------------

  int tageProMonat;

  if (jahr < 0)
    cout << endl << "Fehler: " << jahr << " ist ungltig" << endl;
  else
    if ((monat < 1) || (monat > 12))
      cout << endl << "Fehler: " << monat << " ist ungltig" << endl;
    else
    {
      tageProMonat = TageProMonat[monat-1];
      if ((monat == 2) && (istSchaltjahr(jahr)))
        tageProMonat++;

      if ((tag < 1) || (tag > tageProMonat))
        cout << endl << "Fehler: " << tag << " ist ungltig" << endl;
      else
      {
        tt = tag;
        mm = monat;
        jj = jahr;
      }
    }
}

Datum::Datum(Datum &datum)      // Copy-Konstruktor
{
  cout << endl << "Copy-Konstruktor" << endl;
  tt = datum.tt;
  mm = datum.mm;
  jj = datum.jj;
}

int Datum::getTT()
{
  return tt;
}

int Datum::getMM()
{
  return mm;
}

int Datum::getJJ()
{
  return jj;
}

char *Datum::monatsname()
{
  return Monatsnamen[mm-1];
}

int Datum::lfdTagDesJahres()
{
  int lfd;

  lfd = LfdTagMonatsanfang[mm-1] + tt - 1;
  if ((mm > 2) && (istSchaltjahr()))
    lfd++;
  return lfd;
}

bool Datum::istSchaltjahr()
{
  return istSchaltjahr(jj);
}

bool Datum::istSchaltjahr(int jahr)
{
  // Liefert 'true/1', wenn jahr ein Schaltjahr ist, sonst 'false/0'.

  return  ((jahr%4 != 0) || ((jahr%100 == 0) && (jahr%400 != 0))) ? false : true;
}

Datum Datum::heute()
{
  Datum jetzt;
  
  return jetzt;
}

// ******************************************************************

Person::Person() { };

Person::Person(char einName[], Datum &einDatum, char kennzeichen, char eineAdresse[])
{
  setName(einName);
  setGebDatum(einDatum);
  setGeschlecht(kennzeichen);
  setAdresse(eineAdresse);
}

Person::Person(char einName[], Datum &einDatum, char kennzeichen)
{
  setName(einName);
  setGebDatum(einDatum);
  setGeschlecht(kennzeichen);
  setAdresse(" ");
}

Person::Person(Datum &einDatum, char kennzeichen)
{
  setName(" ");
  setGebDatum(einDatum);
  setGeschlecht(kennzeichen);
  setAdresse(" ");
}

char *Person::getName()
{
  return name;
}

void Person::setName(char neuerName[])
{
  strcpy(name,neuerName);
}

Datum& Person::getGebDatum()
{
  return gebDatum;
}

void Person::setGebDatum(Datum einDatum)
{
  gebDatum = einDatum;
}

char Person::getGeschlecht()
{
  return geschlecht;
}

bool Person::setGeschlecht(char kennzeichen)
{
  geschlecht = kennzeichen;
  return  ((kennzeichen == 'M') || (kennzeichen == 'W')) ? true : false;
}

char *Person::getAdresse()
{
  return adresse;
}

void Person::setAdresse(char neueAdresse[])
{
  strcpy(adresse,neueAdresse);
}

char *Person::anrede()
{
  if (geschlecht == 'M')
    return "Herr";

  if (geschlecht == 'W')
    return "Frau";

  return "";
}

int Person::alter()
{
  Datum heute;

  return (heute.getJJ() - gebDatum.getJJ());
}

// ******************************************************************

Kunde::Kunde() {}      //      ... Standardkonstruktor nicht erlaubt

Kunde::Kunde(char einName[], Datum &einDatum, 
             char kennzeichen, char eineAdresse[]) :
       Person(einName, einDatum, kennzeichen, eineAdresse)
{
  jahresumsatz = 0.0f;
  kreditlimit = 0.0f;
}

Kunde::Kunde(char einName[], Datum &einDatum, char kennzeichen) :
       Person(einName, einDatum, kennzeichen)
{
  jahresumsatz = 0.0f;
  kreditlimit = 0.0f;
}

Kunde::Kunde(Datum &einDatum, char kennzeichen) :
       Person(einDatum, kennzeichen)
{
  jahresumsatz = 0.0f;
  kreditlimit = 0.0f;
}

float Kunde::getJahresumsatz()
{
  return jahresumsatz;
}

void Kunde::setJahresumsatz(float eineZahl)
{
  jahresumsatz = eineZahl;
}

float Kunde::getKreditlimit()
{
  return kreditlimit;
}

void Kunde::setKreditlimit(float eineZahl)
{
  kreditlimit = eineZahl;
}

// ******************************************************************

int   Mitarbeiter::LetztePersNr = 0;
float Mitarbeiter::MaxGehalt = 4500.0f;

Mitarbeiter::Mitarbeiter(char einName[], Datum &einDatum, 
                         char kennzeichen, char eineAdresse[]) :
             Person(einName, einDatum, kennzeichen, eineAdresse)
{
  persNr = 0;
  setStellung("Mitarbeiter4Par");
  setGrundgehalt(1200.0f);
  persNrNeu();
}

Mitarbeiter::Mitarbeiter(char einName[], Datum &einDatum, char kennzeichen) :
             Person(einName, einDatum, kennzeichen)
{
  persNr = 0;
  setStellung("Mitarbeiter3Par");
  setGrundgehalt(1200.0f);
  persNrNeu();
}

Mitarbeiter::Mitarbeiter(Datum &einDatum, char kennzeichen) :
             Person(einDatum, kennzeichen)
{
  persNr = 0;
  setStellung("Mitarbeiter2Par");
  setGrundgehalt(1200.0f);
  persNrNeu();
}

int Mitarbeiter::getPersNr()
{
  return persNr;
}

char *Mitarbeiter::getStellung()
{
  return stellung;
}

void Mitarbeiter::setStellung(char neueStellung[])
{
  strcpy(stellung,neueStellung);
}

float Mitarbeiter::getGrundgehalt()
{
  return grundgehalt;
}

bool Mitarbeiter::setGrundgehalt(float eineZahl)
{
  if (eineZahl <= getMaxGehalt())
  {
    grundgehalt = eineZahl;
    return true;
  }
  cout << "Grundgehalt von " << "Mitarbeiter"
       << " kann maximal sein: " << getMaxGehalt() << endl;
  return false;
}

Organisation& Mitarbeiter::getOrganisation()
{
  return *org;
}

void Mitarbeiter::setOrganisation(Organisation &eineOrg)
{
  org = &eineOrg;
  eineOrg.addMitarbeiter(*this);
}

char *Mitarbeiter::anrede()
{
  static char x[60];

  if (getGeschlecht() == 'M')
    strcpy(x,"Herr");
  else
    strcpy(x,"Frau");
  strcat(x," ");
  strcat(x,getStellung());
  strcat(x," ");
  strcat(x,getName());
  return x;
}

bool Mitarbeiter::persNrNeu()
{
  if (persNr == 0)
  {
    setLetztePersNr(getLetztePersNr() + 1);
    persNr = getLetztePersNr();
    return true;
  }

  cout << endl << "Mitarbeiter " << getName()
               << " hat bereits eine PersonalNummer" << endl;
  return false;
}

float Mitarbeiter::verdient()
{
  return getGrundgehalt();
}

int Mitarbeiter::getLetztePersNr()
{
  return LetztePersNr;
}

void Mitarbeiter::setLetztePersNr(int eineZahl)
{
  LetztePersNr = eineZahl;
}

float Mitarbeiter::getMaxGehalt()
{
  return MaxGehalt;
}

void Mitarbeiter::setMaxGehalt(float eineZahl)
{
  MaxGehalt = eineZahl;
}

// ******************************************************************

float Manager::Gewinnanteil = 0.05f;
float Manager::MaxGehalt = 15000.0f;

Manager::Manager(char einName[], Datum &einDatum, 
                 char kennzeichen, char eineAdresse[]) :
         Mitarbeiter(einName, einDatum, kennzeichen, eineAdresse)
{
  setStellung("Leiter4Par");
  setGrundgehalt(5000.0f);
}

Manager::Manager(char einName[], Datum &einDatum, char kennzeichen) :
         Mitarbeiter(einName, einDatum, kennzeichen)
{
  setStellung("Leiter3Par");
  setGrundgehalt(5000.0f);
}

Manager::Manager(Datum &einDatum, char kennzeichen) :
         Mitarbeiter(einDatum, kennzeichen)
{
  setStellung("Leiter2Par");
  setGrundgehalt(5000.0f);
}

Organisation& Manager::getGeleiteteOrganisation()
{
  return *geleiteteOrganisation;
}

void Manager::setGeleiteteOrganisation(Organisation &eineOrganisation)
{
//  setOrganisation(eineOrganisation);
  geleiteteOrganisation = &eineOrganisation;
  eineOrganisation.setLeiter(*this);    
}

float Manager::verdient()
{
  return ( getGrundgehalt() + 
      (geleiteteOrganisation->gewinnOhnePraemie() * getGewinnanteil()) );
}

float Manager::getGewinnanteil()
{
  return Gewinnanteil;
}

void Manager::setGewinnanteil(float eineZahl)
{
  Gewinnanteil = eineZahl;
}

// ******************************************************************

Organisation::Organisation()
{
  setName("OrganisationNeu");
  anzahlMitarb = 0;
  sachkosten = 0.0f;
}

char *Organisation::getName()
{
  return name;
}

void Organisation::setName(char neuerName[])
{
  strcpy(name,neuerName);
}

Manager& Organisation::getLeiter()
{
  return *leiter;
}

void Organisation::setLeiter(Manager &neuerLeiter)
{
  leiter = &neuerLeiter;
}

Mitarbeiter *Organisation::getMitarbeiterliste()
{
  return *mitarbeiterliste;
}

int Organisation::getAnzahlMitarb()
{
  return anzahlMitarb;
}

void Organisation::setMitarbeiterliste(Mitarbeiter neueMitarbeiterliste[])
{
  *mitarbeiterliste = neueMitarbeiterliste;
}

float Organisation::getSachkosten()
{
  return sachkosten;
}

void Organisation::setSachkosten(float eineZahl)
{
  sachkosten = eineZahl;
}

void Organisation::addMitarbeiter(Mitarbeiter &einMitarbeiter)
{
  if (anzahlMitarb < MAXANZAHL)
  {
    mitarbeiterliste[anzahlMitarb] = &einMitarbeiter;
    anzahlMitarb++;
  }
  else
    cout << "Organisation hat bereits "
         << MAXANZAHL << " Mitarbeiter!" << endl;
}

void Organisation::removeMitarbeiter(Mitarbeiter &einMitarbeiter)
{
  if (anzahlMitarb > 0)
  {
    mitarbeiterliste[anzahlMitarb] = NULL;
    anzahlMitarb--;
  }
  else
    cout << "Organisation hat keine Mitarbeiter!" << endl;
}

void Organisation::druckeAlleMitarbeiter()
{
  cout << endl << "Organisation: " << getName() << endl;

  if (leiter != NULL)
    cout << "geleitet von: " << leiter->getName() << endl;
  else
    cout << "noch kein Manager als Leiter ernannt!" << endl;

  cout << "Anzahl Mitarbeiter = " << anzahlMitarb << endl;
  for (int i = 0; i < anzahlMitarb; i++)
    cout << mitarbeiterliste[i]->anrede()
         << " (Grundgehalt = "
         << mitarbeiterliste[i]->getGrundgehalt()
         << ")"
         << endl;
}

void Organisation::druckeKostenUebersicht()
{
  cout <<  "Organisation: " << getName() << "   Kostenbersicht" << endl;
  cout << "---------------------------------------------------------------------------" << endl;
  cout << "Mitarbeiter \t\t\t\t Grundgehalt \t Verdienst" << endl;
  cout << "---------------------------------------------------------------------------" << endl;
  for (int i = 0; i < anzahlMitarb; i++)
    cout << mitarbeiterliste[i]->anrede() << " \t " <<
            mitarbeiterliste[i]->getGrundgehalt() << " \t " <<
            mitarbeiterliste[i]->verdient() << endl;
  cout << "---------------------------------------------------------------------------" << endl;
  cout << "Personalkosten = " << personalkosten() << endl;
  cout << "Praemie =        " << praemie() << endl;
  cout << "Sachkosten =     " << getSachkosten() << endl;
  cout << "Gesamtkosten =   " << gesamtkosten() << endl;
  cout << "Gewinn =         " << gewinn() << endl;
}

float Organisation::personalkostenOhnePraemie()
{
  // Berechnung der Personalkosten aus den Grundgehltern der Mitarbeiter

  float summe = 0.0f;

  for (int i = 0; i < anzahlMitarb; i++)
    summe = summe + mitarbeiterliste[i]->getGrundgehalt();
  return summe;
}

float Organisation::gesamtkostenOhnePraemie()
{
  return personalkostenOhnePraemie() + getSachkosten();
}

float Organisation::praemie()
{
  // Berechnung der Prmie des Leiters der Organisation

  return gewinnOhnePraemie() * leiter->getGewinnanteil();
}

float Organisation::personalkosten()
{
  // Berechnung der Personalkosten aus den Grundgehltern + Prmien der Mitarbeiter

  return personalkostenOhnePraemie() + praemie();
}

float Organisation::gesamtkosten()
{
  return gesamtkostenOhnePraemie() + praemie();
}

float Organisation::gewinn()
{
  return gewinnOhnePraemie() - praemie();
}

// ******************************************************************

Abteilung::Abteilung()
{
  einnahmen = 0.0f;
}

float Abteilung::getEinnahmen()
{
  return einnahmen;
}

void Abteilung::setEinnahmen(float eineZahl)
{
  einnahmen = eineZahl;
}

void Abteilung::addiereZuEinnahmen(float eineZahl)
{
  einnahmen += eineZahl;
}

float Abteilung::gewinnOhnePraemie()
{
  return (getEinnahmen() - gesamtkostenOhnePraemie());
}

// ******************************************************************

Projekt::Projekt()
{
  planZeit = 1;
  planJahresgewinn = 0.0f;
  planLebensdauer = 0;
}

int Projekt::getPlanZeit()
{
  return planZeit;
}

void Projekt::setPlanZeit(int eineZahl)
{
  planZeit = eineZahl;
}

float Projekt::getPlanJahresgewinn()
{
  return planJahresgewinn;
}

void Projekt::setPlanJahresgewinn(float eineZahl)
{
  planJahresgewinn = eineZahl;
}

int Projekt::getPlanLebensdauer()
{
  return planLebensdauer;
}
  
void Projekt::setPlanLebensdauer(int eineZahl)
{
  planLebensdauer = eineZahl;
}

float Projekt::gewinnOhnePraemie()
{
  return ( (planJahresgewinn * planLebensdauer) / (planZeit * 12)
                     - gesamtkostenOhnePraemie() );
}
