#include "stdafx.h"
#include <time.h>
#include <iostream>
#include "Datum.h"

using namespace std;

char Datum::Monatsnamen [12][9+1] = { "Jnner   ",
                                      "Februar  ",
                                      "Mrz     ",
                                      "April    ",
                                      "Mai      ",
                                      "Juni     ",
                                      "Juli     ",
                                      "August   ",
                                      "September",
                                      "Oktober  ",
                                      "November ",
                                      "Dezember " };

int Datum::TageProMonat [12]       = { 31,  28,  31,  30,  31,  30,  31,  31,  30,  31,  30,  31 };

int Datum::LfdTagMonatsanfang [12] = {  1,  32,  60,  91, 121, 152, 182, 213, 244, 274, 305, 335 };

Datum::Datum()                   // Standardkonstruktor
{
  time_t ltime;
  struct tm *today;
  
  time(&ltime);
  today = localtime(&ltime);

  tt = today->tm_mday;
  mm = today->tm_mon + 1;
  jj = today->tm_year + 1900;
}

Datum::Datum(int tag, int monat, int jahr)
{
  time_t ltime;
  struct tm *today;
  
  time(&ltime);
  today = localtime(&ltime);

  tt = today->tm_mday;
  mm = today->tm_mon + 1;
  jj = today->tm_year + 1900;

  // ----------------------------

  int tageProMonat;

  if (jahr < 0)
    cout << endl << "Fehler: " << jahr << " ist ungltig" << endl;
  else
    if ((monat < 1) || (monat > 12))
      cout << endl << "Fehler: " << monat << " ist ungltig" << endl;
    else
    {
      tageProMonat = TageProMonat[monat-1];
      if ((monat == 2) && (istSchaltjahr(jahr)))
        tageProMonat++;

      if ((tag < 1) || (tag > tageProMonat))
        cout << endl << "Fehler: " << tag << " ist ungltig" << endl;
      else
      {
        tt = tag;
        mm = monat;
        jj = jahr;
      }
    }
}

Datum::Datum(Datum &datum)       // Copy-Konstruktor
{
  cout << endl << "Copy-Konstruktor" << endl;
  tt = datum.tt;
  mm = datum.mm;
  jj = datum.jj;
}

int Datum::getTT()
{
  return tt;
}

int Datum::getMM()
{
  return mm;
}

int Datum::getJJ()
{
  return jj;
}

char *Datum::monatsname()
{
  return Monatsnamen[mm-1];
}

int Datum::lfdTagDesJahres()
{
  int lfd;

  lfd = LfdTagMonatsanfang[mm-1] + tt - 1;
  if ((mm > 2) && (istSchaltjahr()))
    lfd++;
  return lfd;
}

bool Datum::istSchaltjahr()
{
  return istSchaltjahr(jj);
}

bool Datum::istSchaltjahr(int jahr)
{
  // Liefert 'true/1', wenn jahr ein Schaltjahr ist, sonst 'false/0'.

  return  ((jahr%4 != 0) || ((jahr%100 == 0) && (jahr%400 != 0))) ? false : true;
}

Datum Datum::heute()
{
  Datum jetzt;
  
  return jetzt;
}
