/*
 * ErfassenSchreiben.java
 */
package at.beringer.oopBuch.einAusgabe;

import at.beringer.oopBuch.daoKlassen.DAOerfassenSchueler;
import at.beringer.oopBuch.daoKlassen.DAOschreibenSchueler;

/**
Einfache Konsolenanwendung für Erfassen (Lesen) von Daten über die 
Standardeingabe (= Tastatur) und Schreiben der Daten in eine Datei.
<p>
Der Dateiname wird beim Aufruf als Parameter übergeben.
</p>

<hr />

@since August 2000
@version Juli 2002 (Zeichenkette mit variabler Länge)
@version <br />August 2007 (eigene Programmklasse)

@see DAOerfassenSchueler
@see DAOschreibenSchueler

@see ProgrammErfassenSchreiben

@see at.beringer.oopBuch.jdbc.ErfassenSchreibenDB
@see LesenAusgeben

@author Beringer Alfred
*/
public class ErfassenSchreiben
{
    // -------------------------------------------------------------------------
    // Instanzmethoden
    // -------------------------------------------------------------------------

    /**
    Öffentliche Methode zum Starten der Applikation.

    @param  dateiname  Name der Ausgabedatei (als Zeichenkette)
    */
    public void start(String dateiname)
    {
        DAOerfassenSchueler   eingabedaten = new DAOerfassenSchueler();
        DAOschreibenSchueler  ausgabedaten = new DAOschreibenSchueler();
        boolean               ok;

        // Am Beginn der Applikation Datei öffnen
        if (!ausgabedaten.oeffnen(dateiname))
        {
            System.err.println("Fehler beim Öffnen der Datei " 
                               + dateiname
                               + "   --->   Ende");
            return;
        }

        ok = eingabedaten.lesen();           // Lesen Standardeingabe (Tastatur)
        while (!eingabedaten.getEof())
        {
            if (ok)
            {
                // nur zum Testen:
                System.out.println(eingabedaten.getSchueler());

                // Daten übernehmen (Datenobjekt füllen mit den Eingabedaten)
                ausgabedaten.setSchueler(eingabedaten.getSchueler());
                ausgabedaten.schreiben();                 // Datensatz schreiben
            }
            else
            {
                System.err.println("Fehler beim Erfassen!");
            }
            ok = eingabedaten.lesen();       // Lesen Standardeingabe (Tastatur)
        }

        // Am Ende der Applikation Datei schließen
        ausgabedaten.schliessen();
    }
}
