/*
 * LesenAusgeben.java
 */
package at.beringer.oopBuch.einAusgabe;

import at.beringer.oopBuch.daoKlassen.DAOlesenSchueler;
import at.beringer.oopBuch.daoKlassen.DAOausgebenSchueler;

/**
Einfache Konsolenanwendung für Lesen von Daten aus einer Datei und 
Ausgeben (Schreiben) der Daten auf die Standardausgabe (= Bildschirm).
<p>
Der Dateiname wird beim Aufruf als Parameter übergeben.
</p>

<hr />

@since August 2000
@version Juli 2002 (Zeichenkette mit variabler Länge)
@version <br />August 2007 (eigene Programmklasse)

@see DAOlesenSchueler
@see DAOausgebenSchueler

@see ProgrammLesenAusgeben

@see at.beringer.oopBuch.jdbc.LesenDBAusgeben
@see ErfassenSchreiben

@author Beringer Alfred
*/
public class LesenAusgeben
{
    // -------------------------------------------------------------------------
    // Instanzmethoden
    // -------------------------------------------------------------------------

    /**
    Öffentliche Methode zum Starten der Applikation.

    @param  dateiname  Name der Eingabedatei (als Zeichenkette)
    */
    public void start(String dateiname)
    {
        DAOlesenSchueler     eingabedaten = new DAOlesenSchueler();
        DAOausgebenSchueler  ausgabedaten = new DAOausgebenSchueler();
        boolean              ok;

        // Am Beginn der Applikation Datei öffnen
        if (!eingabedaten.oeffnen(dateiname))
        {
            System.err.println("Fehler beim Öffnen der Datei " 
                               + dateiname
                               + "   --->   Ende");
            return;
        }

        ok = eingabedaten.lesen();                            // Lesen Datensatz
        while (!eingabedaten.getEof())
        {
            if (ok)
            {
                // Daten übernehmen (Datenobjekt füllen mit den Eingabedaten)
                ausgabedaten.setSchueler(eingabedaten.getSchueler());
                ausgabedaten.schreibenZeile();              // 1 Zeile schreiben
            }
            else
            {
                System.err.println("Fehler beim Lesen!");
            }
            ok = eingabedaten.lesen();                        // Lesen Datensatz
        }

        // Am Ende der Applikation Datei schließen
        eingabedaten.schliessen();
    }
}
