/*
 * ParameterTesten.java
 */
package at.beringer.oopBuch.einfacheBsp;

/**
Applikation zum Testen der Parameterübergabe mit Call By Value.

<hr />

@since Mai 2013

@see Person
@see ProgrammParameterTesten

@author Beringer Alfred
*/
public class ParameterTesten
{
    // -------------------------------------------------------------------------
    // Instanzmethoden
    // -------------------------------------------------------------------------

    /**
    Start-Methode zum Testen der Applikation.
    */
    public void start()
    {
        Person  p = new Person(1980, 'M');

        p.aendernVorname("Hugo");
        testen(p);

        System.out.println("Danach noch immer: " + p.heisst());
    }

    /** ------------------------------------------------------------------------
    Methode mit 1 Parameter - dieser Parameter ist ein Referenztyp.
    Der Inhalt des Arguments wird beim Aufruf der Methode in den 
    Parameter 'param' kopiert (call by value!). Dieser Inhalt ist eine Referenz 
    auf ein 'Person'-Objekt. D.h.: 
        Die beiden Variablen (Argument und Parameter) sind an ein und dasselbe 
        'Person'-Objekt gebunden. Es gibt also während der Methodendurchführung 
        2 Referenzen auf 1 einziges 'Person'-Objekt (daher könnte in der Methode
        dieses 'Person'-Objekt modifiziert werden - über die Parameterreferenz).
        Die Bindung des Parameters an dieses eine 'Person'-Objekt kann in der 
        Methode aufgehoben werden, NICHT aber die Bindung des Arguments!!!

    @param  param  Referenz auf ein 'Person'-Objekt
    */
    public void testen(Person param)
    {
        Person  pp = new Person(2013, 'M');

        pp.aendernVorname("Maxi");
        param = pp;                               // nur Referenzkopie geändert!

        System.out.println("   In der Methode: " + param.heisst());
    }
}
