/*
 * Zaehler3.java
 */
package at.beringer.oopBuch.einfacheBsp;

/**
Beispielklasse für Vererbung - entspricht der Klasse 'Zaehler2'.
<p>
Erweiterung der Klasse 'Zaehler' mit einem Klassenattribut für den Endwert.
</p>

<hr />

@since April 2002

@see Zaehler
@see Zaehler3Testen
@see Zaehler2

@author Beringer Alfred
*/
public class Zaehler3 extends Zaehler
{
    // -------------------------------------------------------------------------
    // Klassenattribute
    // -------------------------------------------------------------------------

    /**
    Der größte Wert, den der Zähler annehmen kann, danach muss der Zähler
    zurückgesetzt werden.
    */
    private static int  Endwert = 99;

    // -------------------------------------------------------------------------
    // Überschriebene Instanzmethoden
    // -------------------------------------------------------------------------

    /**
    Überschreibt die entsprechende 'Zaehler'-Methode. <br />
    Der neue Zählerwert wird nun auf Plausibilität geprüft!

    @param  wert  neuer Zählerwert, der zwischen 0 und Endwert liegen muss
    */
    @Override
    protected void setWert(int wert)
    {
        super.setWert(wert);                          // Aufruf der Basismethode
        if ( (getWert() > getEndwert()) || (getWert() < 0) )
        {
            reset();
        }
    }

    // -------------------------------------------------------------------------
    // Klassenmethoden
    // -------------------------------------------------------------------------

    /**
    Liefert den aktuellen Endwert für den Zähler.

    @return  aktueller Endwert
    */
    public static int getEndwert()
    {
        return  Endwert;
    }

    // ----------

    /**
    Definiert einen neuen Endwert für den Zähler - es erfolgt jedoch keine 
    Prüfung auf Plausibilität!

    @param  endwert  neuer (beliebiger) Endwert
    */
    public static void setEndwert(int endwert)
    {
        Endwert = endwert;
    }
}
