/*
 * Standardfenster.java
 */
package at.beringer.oopBuch.guiJavaFX;

import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.*;
import javafx.scene.control.*;

/**
Einfachstes Hauptfenster mit Menüzeile (ohne Ereignisse).
<p>
Dieses JavaFX-Fenster entspricht dem gleichnamigen Swing-Fenster aus dem 
Paket 'at.beringer.oopBuch.guiSwing'.
</p>

<dl>
<dt>Bem.:
  <dd>Eine JavaFX-Applikation wird mit der Klassenmethode 'launch' der Klasse 
      'Application' gestartet.
  <dd>Seit Java 8.0 kann eine JavaFX-Applikation direkt gestartet werden, d.h. 
      eine 'main'-Methode (mit 'Application.launch(args)') ist nicht mehr 
      notwendig.
</dt>
</dl>

<hr />

@since Juni 2013

@see at.beringer.oopBuch.guiSwing.StandardfensterV

@author Beringer Alfred
*/
public class StandardfensterV extends Application
{
    // -------------------------------------------------------------------------
    // Instanzattribute
    // -------------------------------------------------------------------------
      
    private MenuBar   menuezeile  = new MenuBar();

    private Menu      menue1      = new Menu("Menü1");
    private MenuItem  menueItem11 = new MenuItem("1. Menüeintrag Menü1");
    private MenuItem  menueItem12 = new MenuItem("2. Menüeintrag Menü1");
    private MenuItem  menueItem13 = new MenuItem("...");

    private Menu      menue2      = new Menu("Menü2");

    private Menu      menue3      = new Menu("...");

    // -------------------------------------------------------------------------
    // Öffentliche Instanzmethoden
    // -------------------------------------------------------------------------

    /**
    'start'-Methode. <br />
    Das Erzeugen der Menüzeile wird in eine private Methode ausgelagert.
    */
    @Override
    public void start(Stage primaryStage)
    {
        Group  root  = new Group();

        // initialisieren Stage
        primaryStage.setTitle("JavaFX-Standardfenster mit Menüzeile");
        primaryStage.setWidth(480);
        primaryStage.setHeight(260);

        menuBarErstellen();

        // Menüzeile in Fenster einfügen
        root.getChildren().add(menuezeile);

        primaryStage.setScene(new Scene(root));
        primaryStage.show();
    }

    // -------------------------------------------------------------------------
    // Private Instanzmethoden
    // -------------------------------------------------------------------------

    /**
    Erzeugen der Menüzeile.
    */
    private void menuBarErstellen()
    {
        menue1.getItems().add(menueItem11);
        menue1.getItems().add(menueItem12);
        menue1.getItems().add(new SeparatorMenuItem());
        menue1.getItems().add(menueItem13);

        menuezeile.getMenus().addAll(menue1, menue2, menue3);
    }
}
