/*
 * BorderLayoutV.java
 */
package at.beringer.oopBuch.guiSwing;

import javax.swing.*;
import java.awt.*;

/**
Hauptfenster für Darstellung eines BorderLayouts (ohne Ereignisse).

<hr />

@since September 2000
@version Jänner 2002 (Swing ab JDK 1.3)
@version <br />Juni 2012 (ohne ContentPane, ab JDK 6 möglich)

@see ProgrammBorderLayout

@author Beringer Alfred
*/
public class BorderLayoutV extends JFrame
{
    // -------------------------------------------------------------------------
    // Instanzattribute
    // -------------------------------------------------------------------------
      
    private JButton  butNorden  = new JButton("Norden");
    private JButton  butSueden  = new JButton("Süden");
    private JButton  butWesten  = new JButton("Westen");
    private JButton  butOsten   = new JButton("Osten");
    private JButton  butZentrum = new JButton("Zentrum");

    // -------------------------------------------------------------------------
    // Konstruktoren
    // -------------------------------------------------------------------------

    /**
    Standardkonstruktor
    */
    public BorderLayoutV()
    {
        this.setTitle("Swing-Fenster mit BorderLayout");
        this.setSize(480, 260);

        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        this.setLayout(new BorderLayout());

        // GUI-Komponenten dem Fenster hinzufügen 

        this.add(butNorden, BorderLayout.NORTH);
        this.add(butSueden, BorderLayout.SOUTH);
        this.add(butWesten, BorderLayout.WEST);
        this.add(butOsten, BorderLayout.EAST);
        this.add(butZentrum);
                       // entspricht: this.add(butZentrum, BorderLayout.CENTER);
    }
}
