/*
 * FensterWaechterA.java
 */
package at.beringer.oopBuch.guiSwing;

import javax.swing.*;
import java.awt.event.*;

/**
Ereigniswächter für Ereignis "Fenster schließen" - Variante A ('getSource').

<hr />

@since Mai 2000
@version Jänner 2002 (Swing JDK 1.2)

@see Hauptfenster1A
@see ProgrammHauptfenster1A
@see FensterWaechterB

@author Beringer Alfred
*/
public class FensterWaechterA extends WindowAdapter
{
    // -------------------------------------------------------------------------
    // API-Methoden überschreiben
    // -------------------------------------------------------------------------

    /** API-Methode für Schließen des Fensters */
    @Override
    public void windowClosing(WindowEvent evt)
    {
        schliessenFenster(evt);
        // Ereignisobjekt mitgeben, falls Daten vom Ereignis benötigt werden
    }

    // *************************************************************************
    // Ereignisbehandlungsmethoden
    // *************************************************************************
    
    /**
    Methode für "Fenster schließen".

    @param  evt  WindowEvent (von API-Methode 'windowClosing' übernommen)
    */
    private void schliessenFenster(WindowEvent evt)
    {
        /*
        'getSource()' liefert Ereignisquelle als 'Object'-Instanz

        Bem.: Ereignisquelle = jene GUI-Komponente, die ein Ereignis 
                               (z.B. "Fenster schließen") ausgelöst hat
        */
        JFrame  fenster = (JFrame) evt.getSource();

        // ...                 Aktionen vor Schließen des Fensters

        JOptionPane.showMessageDialog(fenster, "Das Fenster wird geschlossen");

        fenster.setVisible(false);
        fenster.dispose();
        System.exit(0);                                      // Programm beenden
    }
}
