/*
 * Hauptfenster2.java
 */
package at.beringer.oopBuch.guiSwing;

import javax.swing.*;
import java.awt.event.*;

/**
Einfaches Hauptfenster mit lokalem Ereigniswächter.
<p>
Lokale Klasse: 'FensterWaechter'
</p>

<hr />

@since Mai 2000
@version Jänner 2002 (Swing JDK 1.2)

@see ProgrammHauptfenster2
@see Hauptfenster1A
@see Hauptfenster1B
@see Hauptfenster3

@author Beringer Alfred
*/
public class Hauptfenster2 extends JFrame
{
    // -------------------------------------------------------------------------
    // Konstruktoren
    // -------------------------------------------------------------------------

    /**
    Standardkonstruktor
    */
    public Hauptfenster2()
    {
        this.setTitle("Swing-Hauptfenster2 - lokale (innere) Klasse");
        this.setSize(480, 260);
        this.addWindowListener(new FensterWaechter());
                                                // anmelden beim Ereigniswächter
    }

    // *************************************************************************
    // Lokale (innere) Klasse
    // *************************************************************************
    
    /**
    Ereigniswächter.
    */
    class FensterWaechter extends WindowAdapter
    {
        // ---------------------------------------------------------------------
        // API-Methoden überschreiben
        // ---------------------------------------------------------------------

        /** API-Methode für Schließen des Fensters */
        @Override
        public void windowClosing(WindowEvent evt)
        {
            schliessenFenster(evt);
            // Ereignisobjekt mitgeben, falls Daten vom Ereignis benötigt werden
        }

        // ---------------------------------------------------------------------
        // Ereignisbehandlungsmethoden
        // ---------------------------------------------------------------------
        
        /**
        Methode für "Fenster schließen".

        @param  evt  WindowEvent (von API-Methode 'windowClosing' übernommen)
        */
        private void schliessenFenster(WindowEvent evt)
        {
            /*
            'getWindow()' liefert zugeordnetes Fenster (= Ereignisquelle,
                          die das Ereignis "Fenster schließen" ausgelöst hat)
                          als 'Window'-Instanz
             */
            JFrame  fenster = (JFrame) evt.getWindow();

            // ...                 Aktionen vor Schließen des Fensters

            JOptionPane.showMessageDialog(fenster,
                                          "Das Fenster wird geschlossen");

            fenster.setVisible(false);
            fenster.dispose();
            System.exit(0);                                  // Programm beenden
        }
    }
    // ********************************************* Ende lokale (innere) Klasse

}                                                  // Ende der Klassendefinition
