/*
 * Hauptfenster3.java
 */
package at.beringer.oopBuch.guiSwing;

import javax.swing.*;
import java.awt.event.*;

/**
Einfaches Hauptfenster mit anonymem Ereigniswächter.
<p>
Anonyme Klasse: von 'WindowAdapter'
</p>

<hr />

@since Mai 2000
@version Jänner 2002 (Swing JDK 1.2)

@see ProgrammHauptfenster3
@see Hauptfenster2
@see Hauptfenster1A
@see Hauptfenster1B

@author Beringer Alfred
*/
public class Hauptfenster3 extends JFrame
{
    // -------------------------------------------------------------------------
    // Konstruktoren
    // -------------------------------------------------------------------------

    /**
    Standardkonstruktor
    */
    public Hauptfenster3()
    {
        this.setTitle("Swing-Hauptfenster3 - anonyme Klasse");
        this.setSize(480, 260);

        // anmelden beim Ereigniswächter mit gleichzeitiger Klassendefinition:
        this.addWindowListener( new WindowAdapter()
              // ***************************************************************
              // anonyme (innere) Klasse
              // ***************************************************************
              {
                  // -----------------------------------------------------------
                  // API-Methoden überschreiben
                  // -----------------------------------------------------------

                  /** API-Methode für Schließen des Fensters */
                  @Override
                  public void windowClosing(WindowEvent evt)
                  {
                      schliessenFenster(evt);
                      // Ereignisobjekt mitgeben, 
                      //   falls Daten vom Ereignis benötigt werden
                  }
              }
              // ********************************** Ende anonyme (innere) Klasse
                              );
    }

    // *************************************************************************
    // Ereignisbehandlungsmethoden (private Methoden des Hauptfensters)
    // *************************************************************************
    
    /**
    Methode für "Fenster schließen".

    @param  evt  WindowEvent (von API-Methode 'windowClosing' übernommen)
    */
    private void schliessenFenster(WindowEvent evt)
    {

        // ...                 Aktionen vor Schließen des Fensters

        JOptionPane.showMessageDialog(this, "Das Fenster wird geschlossen");

        this.setVisible(false);
        this.dispose();
        System.exit(0);                                      // Programm beenden
    }
}                                                  // Ende der Klassendefinition
