/*
 * ProgrammLabelButtonFensterUI.java
 */
package at.beringer.oopBuch.guiSwing;

import javax.swing.JFrame;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

/**
Programmklasse (Applikation) für die Klasse 'LabelButtonFensterV'.
<p>
Look and Feel kann über Parameter voreingestellt werden.
</p>

<hr />

@since Jänner 2002
@version Dezember 2004 (deprecated-Methode 'show' von Window-Klasse ersetzt)
@version <br />Dezember 2007 ('Ocean'-LnF hinzugefügt)

@see LabelButtonFensterV
@see ProgrammLabelButtonFenster

@author Beringer Alfred
*/
public class ProgrammLabelButtonFensterUI
{
    // -------------------------------------------------------------------------
    // Klassenkonstante
    // -------------------------------------------------------------------------

    private static String[]  LnF = { 
              "javax.swing.plaf.mac.MacLookAndFeel",
              "javax.swing.plaf.metal.MetalLookAndFeel",
              "javax.swing.plaf.synth.SynthLookAndFeel",
              "com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel",
              "com.sun.java.swing.plaf.motif.MotifLookAndFeel",
              "com.sun.java.swing.plaf.windows.WindowsLookAndFeel",
              "com.sun.java.swing.plaf.windows.WindowsClassicLookAndFeel"
                                   };
    private static String[]  Auswahl = { 
                                         "Mac",
                                         "Metal",
                                         "Ocean",
                                         "Nimbus",
                                         "Motif",
                                         "Windows",
                                         "WindowsClassic",
                                         "System",
                                         "Swing"
                                       };

    // -------------------------------------------------------------------------
    // Klassenmethode 'main'
    // -------------------------------------------------------------------------

    /**
    Der Einstiegspunkt für die Anwendung.
    <p>
    Beim Aufruf kann das gewünschte LnF als Parameter angegeben werden.
    </p>

    @param  args  gewünschtes LnF (Mac, Metal, Ocean, Nimbus, Motif, 
                                   Windows, WindowsClassic, Swing, System)
    */
    public static void main(String[] args)
    {
        if (args.length == 0)
        {
            info();
        }
        else
        {
            lnfAuswahl(args);
        }
  
        SwingUtilities.invokeLater(new Runnable()
                  {
                      @Override
                      public void run()
                      {
                          JFrame  rahmen = new LabelButtonFensterV();
                          rahmen.setVisible(true);
                      }
                  });
    }

    // -------------------------------------------------------------------------
    // private Klassenmethoden
    // -------------------------------------------------------------------------

    private static void info()
    {
        System.out.println(
                      "Sie können die folgenden LnFs als Parameter angeben:");
        for (int i = 0; i < Auswahl.length; i++)
        {
            System.out.println("     " + Auswahl[i]);
        }
    }

    private static void lnfAuswahl(String[] args)
    {
        int  i = 0;

        try
        {
            for (i = 0; i < LnF.length; i++)
            {
                if ( args[0].equalsIgnoreCase(Auswahl[i]) )
                {
                    UIManager.setLookAndFeel( LnF[i] );
                    System.out.println("LnF " + LnF[i] + " gewählt");
                    break;
                }
            }
            if ( i == LnF.length )
            {
                if ( args[0].equalsIgnoreCase(Auswahl[i]) )
                {
                    UIManager.setLookAndFeel(
                       UIManager.getSystemLookAndFeelClassName() );
                    System.out.println("LnF " + Auswahl[i] + " gewählt");
                }
                else        
                {
                    UIManager.setLookAndFeel(
                       UIManager.getCrossPlatformLookAndFeelClassName());
                    System.out.println("LnF Swing-Standard gewählt");
                }
            }
        }
        catch (Exception e)
        {
            System.out.println("LnF " + LnF[i] + " nicht gefunden");
        }
    }
}
