/*
 * Standardfenster.java
 */
package at.beringer.oopBuch.guiSwing;

import javax.swing.*;

/**
Einfachstes Hauptfenster mit Menüzeile (ohne Ereignisse).

<hr />

@since September 2000
@version Jänner 2002 (Swing ab JDK 1.3)

@see ProgrammStandardfenster
@see at.beringer.oopBuch.guiJavaFX.StandardfensterV

@author Beringer Alfred
*/
public class StandardfensterV extends JFrame
{
    // -------------------------------------------------------------------------
    // Instanzattribute
    // -------------------------------------------------------------------------
      
    private JMenuBar   menuezeile  = new JMenuBar();

    private JMenu      menue1      = new JMenu("Menü1");
    private JMenuItem  menueItem11 = new JMenuItem("1. Menüeintrag Menü1");
    private JMenuItem  menueItem12 = new JMenuItem("2. Menüeintrag Menü1");
    private JMenuItem  menueItem13 = new JMenuItem("...");

    private JMenu      menue2      = new JMenu("Menü2");

    private JMenu      menue3      = new JMenu("...");

    // -------------------------------------------------------------------------
    // Konstruktoren
    // -------------------------------------------------------------------------

    /**
    Standardkonstruktor. <br />
    Das Erzeugen der Menüzeile wird in eine private Methode ausgelagert.
    */
    public StandardfensterV()
    {
        this.setTitle("Swing-Standardfenster mit Menüzeile");
        this.setSize(480, 260);

        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        menuBarErstellen();

        // Menüzeile in Fenster einfügen
        this.setJMenuBar(menuezeile);
    }

    // -------------------------------------------------------------------------
    // Private Instanzmethoden
    // -------------------------------------------------------------------------

    /**
    Erzeugen der Menüzeile.
    */
    private void menuBarErstellen()
    {
        menue1.add(menueItem11);
        menue1.add(menueItem12);
        menue1.addSeparator();
        menue1.add(menueItem13);

        menuezeile.add(menue1);
        menuezeile.add(menue2);
        menuezeile.add(menue3);
    }
}
