/*
 * ErfassenSchreibenDB.java
 */
package at.beringer.oopBuch.jdbc;

import at.beringer.oopBuch.daoKlassen.DAOerfassenSchueler;
import at.beringer.oopBuch.daoKlassen.DAOschreibenDBSchueler;

/**
Einfache Konsolenanwendung für Erfassen (Lesen) von Daten über die 
Standardeingabe (= Tastatur) und Schreiben der Daten in eine Datenbank.

<hr />

@since Juli 2012

@see DAOerfassenSchueler
@see DAOschreibenDBSchueler

@see ProgrammErfassenSchreibenDB

@see at.beringer.oopBuch.einAusgabe.ErfassenSchreiben
@see LesenDBAusgeben

@author Beringer Alfred
*/
public class ErfassenSchreibenDB
{
    // -------------------------------------------------------------------------
    // Instanzmethoden
    // -------------------------------------------------------------------------

    /**
    Öffentliche Methode zum Starten der Applikation.
    */
    public void start()
    {
        DAOerfassenSchueler     eingabedaten = new DAOerfassenSchueler();
        DAOschreibenDBSchueler  ausgabedaten = new DAOschreibenDBSchueler();
        boolean                 ok;

        // Öffnen der Datenbank erfolgt in der DAO-Klasse

        ok = eingabedaten.lesen();           // Lesen Standardeingabe (Tastatur)
        while (!eingabedaten.getEof())
        {
            if (ok)
            {
                // nur zum Testen:
                System.out.println(eingabedaten.getSchueler());

                // Daten übernehmen und Datensatz schreiben
                ausgabedaten.setSchueler(eingabedaten.getSchueler());
                ausgabedaten.schreiben();
            }
            else
            {
                System.err.println("Fehler beim Lesen");
            }
            ok = eingabedaten.lesen();       // Lesen Standardeingabe (Tastatur)
        }

        // Am Ende der Applikation Verbindung zur DB schließen
        ausgabedaten.schliessenVerbindung();
    }
}
