/*
 * Abteilung.java
 */
package at.beringer.oopBuch.organisation;

/**
Instanzen dieser Klasse repräsentieren Abteilungen einer Organisation.

<hr />

@since August 1999

@see Organisation
@see OrganisationTesten

@author Beringer Alfred
*/
public class Abteilung extends Organisation
{
    // -------------------------------------------------------------------------
    // Instanzattribute
    // -------------------------------------------------------------------------

    private float  einnahmen = 0.0f;

    // -------------------------------------------------------------------------
    // Zugriffsmethoden (Get- und Set-Methoden)
    // -------------------------------------------------------------------------

    /**
    Liefert die Einnahmen der Abteilung.

    @return  Einnahmen
    */
    public float getEinnahmen()
    {
        return  einnahmen;
    }

    // ----------

    /** 
    Ändert die Einnahmen der Abteilung.

    @param  einnahmen  neue Einnahmen
    */
    public void setEinnahmen(float einnahmen)
    {
        this.einnahmen = einnahmen;
    }

    // -------------------------------------------------------------------------
    // Sonstige Instanzmethoden
    // -------------------------------------------------------------------------

    /**
    Erhöht die Einnahmen der Abteilung.

    @param  einnahmen  Wert, der zu den Einnahmen addiert wird
    */
    public void addiereZuEinnahmen(float einnahmen)
    {
        this.einnahmen += einnahmen;
    }

    // -------------------------------------------------------------------------

    /**
    Berechnet den Gewinn der Abteilung.

    @see Organisation#gewinnOhnePraemie()
    @see Projekt#gewinnOhnePraemie()

    @return  Einnahmen - Gesamtkosten ohne Prämie
    */
    @Override
    public float gewinnOhnePraemie()
    {
        return  getEinnahmen() - gesamtkostenOhnePraemie();
    }
}
