/*
 * OrganisationTesten.java
 */
package at.beringer.oopBuch.organisation;

import java.time.LocalDate;

/**
Applikation zum Testen des Beispiels "Personen - Mitarbeiter - Organisationen"
(Buch Kap.4.4).
<p>
Die Testdaten werden der Einfachheit halber statisch vordefiniert.
Es gibt keine Eingabedaten!
</p>

<hr />

@since August 1999
@version Jänner 2002 (Eurowerte)
@version <br />August 2007 (eigene Programmklasse)
@version <br />April 2014 (aktualisieren Java 8 - 'GregorianCalendar' ersetzen)

@see Person
@see Mitarbeiter
@see Manager
@see Organisation
@see Abteilung
@see Projekt
@see ProgrammOrganisationTesten

@author Beringer Alfred
*/
public class OrganisationTesten
{
    // -------------------------------------------------------------------------
    // Instanzmethoden
    // -------------------------------------------------------------------------

    /**
    Start-Methode zum Testen der Applikation
    */
    public void start()
    {
        Mitarbeiter  mita11, mita12, mita2, mitp1, mitp21, mitp22;
        Manager      mana1,  mana2,  manp1, manp2;
        Abteilung    abt1,   abt2;
        Projekt      proj1,  proj2;

        abt1 = new Abteilung();
        abt1.setName("Abt1");
        abt1.setEinnahmen(200000.0f);
        abt1.setSachkosten(7000.0f);
        
        abt2 = new Abteilung();
        abt2.setName("Abt2");
        abt2.setEinnahmen(350000.0f);
        
        proj1 = new Projekt();
        proj1.setName("Projekt1");

        proj2 = new Projekt();
        proj2.setName("Projekt2");
        proj2.setSachkosten(5500.0f);
        proj2.setPlanZeit(2);
        proj2.setPlanJahresgewinn(600000.0f);
        proj2.setPlanLebensdauer(6);

//        mita11 = new Mitarbeiter();       ***error*** geht nicht"
        mita11 = new Mitarbeiter(LocalDate.of(1962, 7, 17), 'M');

        mita11.setName("Huber Hans");
        mita11.setGrundgehalt(2100.0f);
        mita11.setOrganisation(abt1);

        mita12 = new Mitarbeiter(LocalDate.of(1977, 1 ,13), 'W');
        mita12.setName("Irene Gross");
        mita12.setGrundgehalt(2500.0f);
        mita12.setOrganisation(abt1);

        mita2  = new Mitarbeiter("Karli", LocalDate.now(), 'M');
        mita2.setOrganisation(abt2);

        mitp1  = new Mitarbeiter("Doris", LocalDate.now(), 'W');
        mitp1.setOrganisation(proj1);

        mitp21 = new Mitarbeiter("Hansi", LocalDate.now(), 'M');
        mitp21.setOrganisation(proj2);

        mitp22 = new Mitarbeiter("Helga", LocalDate.now(), 'W');
        mitp22.setOrganisation(proj2);

        mana1 = new Manager("Klammer Franz", LocalDate.now(), 'M');
        mana1.setGrundgehalt(5500.0f);
        mana1.setOrganisation(abt1);
        mana1.setGeleiteteOrganisation(abt1);

        mana2 = new Manager("Muster Tom", LocalDate.now(), 'M');
        mana2.setOrganisation(abt2);
        mana2.setGeleiteteOrganisation(abt2);

        manp1 = new Manager("Toni", LocalDate.now(), 'M');
        manp1.setOrganisation(proj1);
        manp1.setGeleiteteOrganisation(proj1);

        manp2 = new Manager("Annemarie", LocalDate.now(), 'W');
        manp2.setGrundgehalt(4700.0f);
        manp2.setOrganisation(proj2);
        manp2.setGeleiteteOrganisation(proj2);

        System.out.println("Personalnummern: "
                           + mita11.getPersNr() + " " + mita12.getPersNr() + " "
                           + mita2.getPersNr()  + " " + mitp1.getPersNr()  + " "
                           + mitp21.getPersNr() + " " + mitp22.getPersNr() + " "
                           + mana1.getPersNr()  + " " + mana2.getPersNr()  + " "
                           + manp1.getPersNr()  + " " + manp2.getPersNr());

        System.out.println(mita12.anrede());
        System.out.println(mana1.anrede());

        System.out.println(mita11.alterBerechnen());
        System.out.println(mita12.alterBerechnen());

        System.out.println(mita11.verdient());
        System.out.println(mana1.verdient());
        System.out.println(manp2.verdient());

        abt1.druckeAlleMitarbeiter();    System.out.println();
        abt2.druckeAlleMitarbeiter();    System.out.println();
        proj1.druckeAlleMitarbeiter();   System.out.println();
        proj2.druckeAlleMitarbeiter();   System.out.println();

        abt1.druckeKostenUebersicht();    System.out.println();
        proj2.druckeKostenUebersicht();   System.out.println();
    }
}
