<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® Personal Use Edition, 7.10.1 of 06. Februar 2014 on 31. Mai 2014 at 12:11:33</time-stamp>


<component-created>
<name>oopBuch</name> <type>bundle</type>
</component-created><!-- Bundle oopBuch* -->


<component-property>
<name>oopBuch</name> <type>bundle</type>
<property>comment</property> <value>'Paketbund für die Smalltalk-Beispielklassen aus dem Fachbuch "Objektorientierte Programmierung" von Beringer Alfred.
Beinhaltet die Pakete ''namespaces'', ''einfacheBsp'' und ''organisation''.
'</value>
</component-property>

<component-created>
<name>namespaces</name> <type>package</type>
</component-created><!-- Package namespaces* -->


<component-property>
<name>namespaces</name> <type>package</type>
<property>prerequisiteParcels</property> <value>#(#('Base VisualWorks' ''))</value>
</component-property>

<component-property>
<name>namespaces</name> <type>package</type>
<property>developmentPrerequisites</property> <value>#(#(#any 'Base VisualWorks' ''))</value>
</component-property>

<component-property>
<name>namespaces</name> <type>package</type>
<property>prerequisiteDescriptions</property> <value>#(#(#name 'Base VisualWorks' #componentType #bundle))</value>
</component-property>

<component-property>
<name>namespaces</name> <type>package</type>
<property>comment</property> <value>'Paket für die Namensbereiche für die Smalltalk-Beispielklassen aus dem Buch "Objektorientierte Programmierung" von Beringer Alfred.
'</value>
</component-property>

<name-space>
<name>BeringerOrganisation</name>
<environment>Smalltalk</environment>
<private>false</private>
<imports>
			private Smalltalk.*
			</imports>
<category>OOP-Buch</category>
<attributes>
<package>namespaces</package>
</attributes>
</name-space>

<name-space>
<name>BeringerEinfacheBsp</name>
<environment>Smalltalk</environment>
<private>false</private>
<imports>
			private Smalltalk.*
			</imports>
<category>OOP-Buch</category>
<attributes>
<package>namespaces</package>
</attributes>
</name-space>


<component-created>
<name>einfacheBsp</name> <type>package</type>
</component-created><!-- Package einfacheBsp* -->


<component-property>
<name>einfacheBsp</name> <type>package</type>
<property>prerequisiteParcels</property> <value>#(#('Base VisualWorks' ''))</value>
</component-property>

<component-property>
<name>einfacheBsp</name> <type>package</type>
<property>developmentPrerequisites</property> <value>#(#(#any 'Base VisualWorks' ''))</value>
</component-property>

<component-property>
<name>einfacheBsp</name> <type>package</type>
<property>prerequisiteDescriptions</property> <value>#(#(#name 'Base VisualWorks' #componentType #bundle))</value>
</component-property>

<component-property>
<name>einfacheBsp</name> <type>package</type>
<property>comment</property> <value>'Paket für die Smalltalk-Beispielklassen von Kapitel 2 aus dem Buch "Objektorientierte Programmierung" von Beringer Alfred.
Beinhaltet die Klassen ''Person'', ''Auto'', ''Zaehler'', ''Zaehler2'' und ''Datum'' aus dem Buch. Zusätzlich enthält es noch die Klasse ''Zaehler3''.
'</value>
</component-property>

<class>
<name>Person</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>vorname geburtsjahr geschlecht </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<comment>
<class-id>BeringerEinfacheBsp.Person</class-id>
<body>Eine einfache Personen-Klasse.
Jede Instanz dieser Klasse repräsentiert eine natürliche Person.
Klassenkonstante für gültige Geschlechtskennzeichen.
- Jede Person hat immer ein Geburtsjahr und ein Geschlecht.
- Geburtsjahr und Geschlecht können nicht geändert werden.
- Geburtsjahr und Geschlecht werden geprüft:
- Geburtsjahr darf nicht größer sein als das laufende Jahr, das Geschlecht darf nur 'M' oder 'W' sein.
Es wurde zusätzlich noch die Methode 'printOn:' überschrieben.

Hinweis: Die Namen der Standardzugriffsmethoden entsprechen NICHT den üblichen 
         Smalltalk- bzw. UML-Konventionen ('attribut' bzw. 'attribut:'). 

Class Variables
	MAENNLICH	&lt;Character&gt;	Kennzeichen für männliches Geschlecht
	WEIBLICH		&lt;Character&gt;	Kennzeichen für weibliches Geschlecht

Instance Variables
	vorname		&lt;String&gt;		Vorname
	geburtsjahr		&lt;Integer&gt;		Geburtsjahr
	geschlecht		&lt;Character&gt;	Geschlecht
</body>
</comment>

<class>
<name>Datum</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>jj mm tt </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<comment>
<class-id>BeringerEinfacheBsp.Datum</class-id>
<body>Eine einfache Datumsklasse.

Class Variables
	Monatsnamen			&lt;String-Array&gt;		Monatsnamen
	TageProMonat			&lt;Integer-Array&gt;		Anzahl der Tage jedes Monats
	LfdTagMonatsanfang		&lt;String-Array&gt;		Laufende Tageszahl am 1. jedes Monats


Instance Variables
	jj		&lt;Integer&gt;		Jahr
	mm		&lt;Integer&gt;		Monat
	tt		&lt;Integer&gt;		Tag

**************************************
"DatumTesten"

| dat1 dat2 dat3 |

dat1 := Datum newJahr: 1988 monatsnummer: 2 tag:17.
dat1 istSchaltjahr.			"&lt;Print it&gt; liefert true"
dat1 lfdTagDesJahres.		"&lt;Print it&gt; liefert 48"
dat1.						"&lt;Print it&gt; liefert 17. 2. 1988"
dat2 := Datum heute.
dat2 istSchaltjahr.
dat2 lfdTagDesJahres.
dat3 := Datum new.
dat3 istSchaltjahr.
dat3 lfdTagDesJahres.

"--------------------------------------"

| jj today dat |

jj := 2000.
today := Datum heute.
dat := Datum newJahr: 1950 monatsnummer: 4 tag:25.

Datum istSchaltjahr: jj.			"&lt;Print it&gt; liefert true"

Transcript show: 'today = ';
               show: today tt printString; show: '.';
               show: today mm printString; show: '.';
               show: today jj printString; cr.
today istSchaltjahr.
today lfdTagDesJahres.

Transcript clear.
Transcript show: 'dat = ';
               show: dat tt printString; show: '.';
               show: dat mm printString; show: '.';
               show: dat jj printString; cr.

Transcript show: 'heutiger Tag = ';
               show: Datum heute tt printString; cr;
               show: 'heutiger Monat = ';
               show: Datum heute monatsname printString; cr;
               show: 'aktuelles Jahr = ';
               show: Datum heute jj printString; cr.
</body>
</comment>

<class>
<name>Auto</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>farbe anzahlGaenge geschwindigkeit gang besitzer </inst-vars>
<class-inst-vars>MwstSatz </class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<comment>
<class-id>BeringerEinfacheBsp.Auto</class-id>
<body>Eine sehr einfache Auto-Klasse, jede Instanz dieser Klasse repräsentiert ein Auto.
Jede Instanz wird mit einer Anfangsgeschwindigkeit von 10 km/h initialisiert.
Rauf- und runterschalten bewirkt keine Geschwindigkeitsänderung.
Bremsen und beschleunigen bewirkt immer eine Geschwindigkeitsänderung von 10%, jedoch keinen Gangwechsel.
Es wurde zusätzlich noch (neben der Methode 'zeigeInhalt') die Methode 'printOn:' überschrieben.

Class Instance Variables
	MwstSatz		&lt;Float&gt;	Mehrwertsteuersatz

Instance Variables
	besitzer				&lt;Person&gt;	Besitzer des Autos
	farbe					&lt;String&gt;		Farbe des Autos
	anzahlGaenge		&lt;Integer&gt;		Anzahl der Gänge
	gang					&lt;Integer&gt;		eingelegter Gang
	geschwindigkeit		&lt;Float&gt;		aktuelle Geschwindigkeit

**************************************
"AutoTesten"

| auto |

auto := Auto new.

auto besitzer: (BeringerEinfacheBsp.Person newGeburtsjahr: 1980  geschlecht: $M).
auto farbe: 'blau'.
auto raufschalten.
auto zeigeInhalt.

Auto mwstSatz: 20.
auto besitzer aendernVorname: 'Hugo'.
auto raufschalten.
auto raufschalten.
auto zeigeInhalt.

auto runterschalten.
auto beschleunigen.
auto zeigeInhalt.

auto bremsen.
auto zeigeInhalt.
</body>
</comment>

<class>
<name>Zaehler</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>wert </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<comment>
<class-id>BeringerEinfacheBsp.Zaehler</class-id>
<body>Instanzen dieser Klasse repräsentieren einen einfachen Zähler, der (um 1) erhöht und (auf 0) zurückgesetzt werden kann.

Instance Variables
	wert	&lt;Integer&gt;		aktueller Stand des Zählers

**************************************
"ZaehlerTesten"

| z |

z := Zaehler new.
z erhoehen.
z wert			"&lt;Print It&gt; liefert 1"
</body>
</comment>

<class>
<name>Zaehler2</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>wert </inst-vars>
<class-inst-vars>Endwert </class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<comment>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id>
<body>Instanzen dieser Klasse repräsentieren einen einfachen zweistelligen Zähler, der (um 1) erhöht und (auf 0) zurückgesetzt werden kann.
Der Zähler beginnt nach 99 (= Standardwert für Endwert) wieder bei 0, d.h. bei 100 erfolgt ein Überlauf.

Class Instance Variables
	Endwert	&lt;Integer&gt;		maximaler Wert des Zählers

Instance Variables
	wert	&lt;Integer&gt;		aktueller Stand des Zählers

**************************************
"Zaehler2Testen"

| z |

Transcript clear.

z := Zaehler2 new.
z erhoehen.
1 to: 3 do: [ :k |
	1 to: 80 do: [ :i |
		z erhoehen 
	].
	Transcript cr;
			show: z wert printString
]
</body>
</comment>

<class>
<name>Zaehler3</name>
<environment>BeringerEinfacheBsp</environment>
<super>BeringerEinfacheBsp.Zaehler</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars>Endwert </class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<comment>
<class-id>BeringerEinfacheBsp.Zaehler3</class-id>
<body>Beispielklasse für Vererbung - entspricht der Klasse 'Zaehler2'.
Erweiterung der Klasse 'Zaehler' mit einem Klassenattribut für den Endwert.

Class Instance Variables
	Endwert	&lt;Integer&gt;		maximaler Wert des Zählers

**************************************
"Zaehler3Testen"

| z |

Transcript clear.

z := Zaehler3 new.
z erhoehen.
1 to: 3 do: [ :k |
	1 to: 80 do: [ :i |
		z erhoehen 
	].
	Transcript cr;
			show: z wert printString
]
</body>
</comment>

<shared-variable>
<name>LfdTagMonatsanfang</name>
<environment>BeringerEinfacheBsp.Datum</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>#(1 32 60 91 121 152 182 213 244 274 305 335)</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>


<shared-variable>
<name>Monatsnamen</name>
<environment>BeringerEinfacheBsp.Datum</environment>
<private>false</private>
<constant>false</constant>
<category>Klassenvariable</category>
<initializer>#('Jänner' 'Februar' 'März' 'April' 'Mai' 'Juni' 'Juli' 'August' 'September' 'Oktober' 'November' 'Dezember' )</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>


<shared-variable>
<name>TageProMonat</name>
<environment>BeringerEinfacheBsp.Datum</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>#(31 28 31 30 31 30 31 31 30 31 30 31)</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>



<shared-variable>
<name>MAENNLICH</name>
<environment>BeringerEinfacheBsp.Person</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>$M</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>


<shared-variable>
<name>WEIBLICH</name>
<environment>BeringerEinfacheBsp.Person</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>$W</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>



<methods>
<class-id>BeringerEinfacheBsp.Zaehler class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="new">new
	"Standardkonstruktor.
	 Zähler wird zurückgesetzt."

	^ super new reset</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Zaehler</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="wert">wert

	^ wert</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="erhoehen">erhoehen
	"Erhöht den Zähler um 1."

	self wert: (self wert + 1).

	"Einfacher, aber mit weniger Datenkapselung:
		wert := wert + 1.		"

	^ self wert</body>

<body package="einfacheBsp" selector="reset">reset
	"Setzt den Zähler zurück auf 0.
	 Kein expliziter Rückgabewert - somit wird das Zaehler-Objekt selbst zurückgegeben (entspricht   ^self)."

	self wert: 0

	"Einfacher, aber mit weniger Datenkapselung:
		wert := 0			"</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler</class-id> <category>private</category>

<body package="einfacheBsp" selector="wert:">wert: neuerWert
	"Ändert den Wert des Zählers - es erfolgt jedoch keine Prüfung auf Plausibilität!"

	wert := neuerWert</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Zaehler2 class</class-id> <category>class initialization</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Klassenkonstruktor.
	 Für einen zweistelligen Zähler wird der Endwert auf 99 gesetzt."

	Endwert := 99</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2 class</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="endwert">endwert

	^ Endwert</body>

<body package="einfacheBsp" selector="endwert:">endwert: endwert
	"Definiert einen neuen Endwert für den Zähler - es erfolgt jedoch keine Prüfung auf Plausibilität!"

	Endwert := endwert</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2 class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="new">new
	"Standardkonstruktor.
	 Zähler wird zurückgesetzt."

	^ super new reset</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="wert">wert

	^ wert</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="reset">reset
	"Setzt den Zähler zurück auf 0.
	 Kein expliziter Rückgabewert - somit wird das Zaehler-Objekt selbst zurückgegeben (entspricht   ^self)."

	self wert: 0</body>

<body package="einfacheBsp" selector="erhoehen">erhoehen
	"Erhöht den Zähler um 1 - bei Überlauf wird Zähler zurückgesetzt."

	self wert: (self wert + 1).
	^ self wert</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id> <category>private</category>

<body package="einfacheBsp" selector="wert:">wert: neuerWert
	"Ändert den Wert des Zählers.
	 Der neue Wert muss zwischen 0 und Endwert liegen."

	wert := neuerWert.
	( (self wert &gt; self class endwert) or: [self wert &lt; 0] ) 
		ifTrue: [
			self reset
		]</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Zaehler3 class</class-id> <category>class initialization</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Klassenkonstruktor.
	 Für einen zweistelligen Zähler wird der Endwert auf 99 gesetzt."

	Endwert := 99</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler3 class</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="endwert">endwert

	^ Endwert</body>

<body package="einfacheBsp" selector="endwert:">endwert: endwert
	"Definiert einen neuen Endwert für den Zähler - es erfolgt keine Prüfung auf Plausibilität!"

	Endwert := endwert</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Zaehler3</class-id> <category>private</category>

<body package="einfacheBsp" selector="wert:">wert: neuerWert
	"Überschreibt die entsprechende 'Zaehler'-Methode.
	 Der neue Zählerwert wird nun auf Plausibilität geprüft: Er muss zwischen 0 und Endwert liegen."

	super wert: neuerWert.
	( (self wert &gt; self class endwert) or: [self wert &lt; 0] )
		ifTrue: [
			self reset
		]</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Person class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="newGeburtsjahr:geschlecht:">newGeburtsjahr: einJahr geschlecht: kennzeichen
	"Jede Person muss ein Geburtsjahr und ein Geschlecht haben.
	 Standardkonstruktor ist nicht erlaubt."

	^ (super new)
		aendernGeburtsjahr: einJahr;
		aendernGeschlecht: kennzeichen;
		initialize</body>

<body package="einfacheBsp" selector="new">new
	"Eine Personeninstanz kann nur mit Geburtsdatum und Geschlecht erzeugt werden."

	self
		error: 'Keine Daten (mindestens Geburtsdatum und Geschlecht sind anzugeben)'</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Person</class-id> <category>initialize-release</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Initialisiert ein neu erzeugtes Objekt."

	super initialize.
	^ self</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Person</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="geboren">geboren

	^ geburtsjahr</body>

<body package="einfacheBsp" selector="hatGeschlecht">hatGeschlecht

	^ geschlecht</body>

<body package="einfacheBsp" selector="aendernVorname:">aendernVorname: neuerVorname

	vorname := neuerVorname</body>

<body package="einfacheBsp" selector="heisst">heisst

	^ vorname</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Person</class-id> <category>printing</category>

<body package="einfacheBsp" selector="printOn:">printOn: aStream
	"Dient zur textuellen Darstellung einer Personeninstanz.
	 Ermöglicht der Methode 'printString' eine sinnvolle Ausgabe."

	aStream
		nextPutAll: self class name , ': ' , self heisst printString , ' (' , self geboren printString , ') '</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Person</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="alterBerechnen">alterBerechnen
	"Berechnet das Alter der Person. Date ist eine Standardklasse von VisualWorks."

	^ (Date today year - self geboren)</body>

<body package="einfacheBsp" selector="anrede">anrede
	"Liefert die Anrede für die Person (abhängig vom Geschlecht).
	 Die Anrede ist fix codiert und nicht variabel!"

	(self hatGeschlecht = MAENNLICH)
		ifTrue: [
			^ 'Sehr geehrter Herr'
		].

	^ 'Sehr geehrte Frau'</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Person</class-id> <category>private</category>

<body package="einfacheBsp" selector="aendernGeburtsjahr:">aendernGeburtsjahr: einJahr
	"Setzt das Geburtsjahr der Person.
	 Das Geburtsjahr wird auf Gültigkeit geprüft:   (Geburtsjahr &lt;= laufendes Jahr).
	 Bei einem Fehler wird das Geburtsjahr nicht gesetzt!"

	( einJahr &lt;= Date today year )
		ifTrue: [
			geburtsjahr := einJahr.
			^ true
		].

	"ungültiges Geburtsjahr"
	^ false</body>

<body package="einfacheBsp" selector="aendernGeschlecht:">aendernGeschlecht: kennzeichen
	"Setzt das Geschlecht der Person.
	 Das Geschlecht wird auf Gültigkeit geprüft.
	 Bei einem Fehler wird das Geschlecht nicht gesetzt!"

	( (kennzeichen = MAENNLICH) or: [kennzeichen = WEIBLICH] )
		ifTrue: [
			geschlecht := kennzeichen.
			^ true
		].

	"ungültiges Kennzeichen für Geschlecht"
	^ false</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Datum class</class-id> <category>testing</category>

<body package="einfacheBsp" selector="istSchaltjahr:">istSchaltjahr: jahr
	" Liefert 'true', wenn jahr ein Schaltjahr ist, sonst 'false'. "

	( jahr \\ 4 ~= 0 or: [ jahr \\ 100 = 0 and: [ jahr \\ 400 ~= 0 ] ] )
		ifTrue: [
			^ false
		].

	^ true</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="newJahr:monatsnummer:tag:">newJahr: jahr monatsnummer: monat tag: tag

	^ (super new) jj: jahr mm: monat tt: tag</body>

<body package="einfacheBsp" selector="new">new

	| heute |

	heute := Date today.
	^ Datum
		newJahr: heute year
		monatsnummer: heute monthIndex
		tag: heute dayOfMonth</body>

<body package="einfacheBsp" selector="heute">heute

	^ Datum new</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="jj">jj

	^ jj</body>

<body package="einfacheBsp" selector="monatsname">monatsname

	^ Monatsnamen at: self mm</body>

<body package="einfacheBsp" selector="mm">mm

	^ mm</body>

<body package="einfacheBsp" selector="tt">tt

	^ tt</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>testing</category>

<body package="einfacheBsp" selector="istSchaltjahr">istSchaltjahr

	^ self class istSchaltjahr: self jj</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="lfdTagDesJahres">lfdTagDesJahres

	| lfd |
	lfd := (LfdTagMonatsanfang at: self mm) + self tt - 1.
	( self mm &gt; 2 and: [self istSchaltjahr] )
		ifTrue: [
			lfd := lfd + 1
		].
	^ lfd</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>printing</category>

<body package="einfacheBsp" selector="printOn:">printOn: aStream
	"Datum in Form von TT. MM. JJJJ."

	aStream
		nextPutAll: self tt printString , '. ' , self mm printString , '. ' , self jj printString</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>private</category>

<body package="einfacheBsp" selector="jj:mm:tt:">jj: jahr mm: monat tt: tag
	"Datum wird geprüft.
	 Die Fehlerbehandlung ist der Einfachheit halber sehr primitiv, denn ein falsches Datum bewirkt einen Programmabsturz!"

	| tageProMonat |

	(jahr = 0)
		ifTrue: [
			self error: 'ungültiges Jahr'
		].
	( monat &lt; 1 or: [monat &gt; 12] )
		ifTrue: [
			self error: 'ungültiger Monat'
		].
	tageProMonat := TageProMonat at: monat.
	( monat = 2 and: [Datum istSchaltjahr: jahr] )
		ifTrue: [
			tageProMonat := tageProMonat + 1
		].
	( tag &lt; 1 or: [tag &gt; tageProMonat] )
		ifTrue: [
			self error: 'ungültiger Tag'
		].
	jj := jahr.
	mm := monat.
	tt := tag</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Auto class</class-id> <category>class initialization</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Klassenkonstruktor.
	 Initialisiert Klassenvariable und/oder Klasseninstanzvariable."

	MwstSatz := 20</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto class</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="mwstSatz">mwstSatz

	^ MwstSatz</body>

<body package="einfacheBsp" selector="mwstSatz:">mwstSatz: mwstSatz

	MwstSatz := mwstSatz</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="new">new
	"Standardkonstruktor."

	^ super new initialize</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Auto</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="farbe">farbe

	^ farbe</body>

<body package="einfacheBsp" selector="geschwindigkeit:">geschwindigkeit: neueGeschwindigkeit
	"Ändert die aktuelle Geschwindigkeit.
	 Es erfolgt aber keine Prüfung auf Plausibilität!"

	geschwindigkeit := neueGeschwindigkeit</body>

<body package="einfacheBsp" selector="besitzer:">besitzer: neuerBesitzer

	besitzer := neuerBesitzer</body>

<body package="einfacheBsp" selector="geschwindigkeit">geschwindigkeit

	^ geschwindigkeit</body>

<body package="einfacheBsp" selector="besitzer">besitzer

	^ besitzer</body>

<body package="einfacheBsp" selector="gang:">gang: neuerGang
	"Legt anderen Gang ein - es erfolgt eine Prüfung auf Gültigkeit!
	 Der eingelegte Gang kann nicht kleiner sein als 1 und nicht höher als die Anzahl der Gänge.
	 Bei einem Fehler wird der Gang nicht geändert."

	( (neuerGang &gt;= 1) and: [neuerGang &lt;= anzahlGaenge] )
		ifTrue: [
			gang := neuerGang
		]</body>

<body package="einfacheBsp" selector="anzahlGaenge:">anzahlGaenge: neueAnzahlGaenge
	"Ändert die Maximalanzahl der Gänge des Autos - dies entspricht einem Umbau des Autos.
	 Der eingelegte Gang wird auf 1 zurückgesetzt."

	(neueAnzahlGaenge &gt;= 1)
		ifTrue: [
			anzahlGaenge := neueAnzahlGaenge
		].
	self gang: 1</body>

<body package="einfacheBsp" selector="gang">gang

	^ gang</body>

<body package="einfacheBsp" selector="anzahlGaenge">anzahlGaenge

	^ anzahlGaenge</body>

<body package="einfacheBsp" selector="farbe:">farbe: neueFarbe

	farbe := neueFarbe</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto</class-id> <category>printing</category>

<body package="einfacheBsp" selector="printOn:">printOn: aStream
	"Vererbte Methode 'printOn:' überschreiben.
	Dient zur textuellen Darstellung einer Auto-Instanz.
	Ermöglicht der Methode 'printString' eine sinnvolle Ausgabe.

	Achtung: Besitzer sollte bereits initialisiert sein!

	String-Darstellung einer Auto-Instanz:
	            Auto-Daten: [ Mehrwertsteuersatz = ...%
	                 Besitzer = ..., Farbe = ..., Anzahl Gaenge = ...
	                 eingelegter Gang = ... / aktuelle Geschwindigkeit = ... ]"

	aStream
		nextPutAll: self class name , '-Daten: [ Mehrwertsteuersatz = ' , self class mwstSatz printString , '%' ; cr;
		nextPutAll: '     Besitzer = ' , self besitzer heisst printString
					 , ', Farbe = ' , self farbe printString
					 , ', Anzahl Gänge = ' , self anzahlGaenge printString	; cr;
		nextPutAll: '     eingelegter Gang = ' , self gang printString
					 , ' / aktuelle Geschwindigkeit = ' , self geschwindigkeit printString
					 , ' ]'</body>

<body package="einfacheBsp" selector="zeigeInhalt">zeigeInhalt
	"Schreibt alle Attribute in die Standardausgabe.
	 Anstelle dieser Methode sollte besser die Methode 'printOn:' überschrieben werden.

	 Achtung: Besitzer sollte bereits initialisiert sein!"

	Transcript
		cr; show: self class name , '-Daten: [ Mehrwertsteuersatz = ' , self class mwstSatz printString , '%';
		cr; show: '     Besitzer = ' , self besitzer heisst printString
					, ', Farbe = ' , self farbe printString
					, ', Anzahl Gänge = ' , self anzahlGaenge printString;
		cr; show: '     eingelegter Gang = ' , self gang printString
					, ' / aktuelle Geschwindigkeit = ' , self geschwindigkeit printString
					, ' ]'</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="beschleunigen">beschleunigen

	geschwindigkeit := geschwindigkeit * 1.1</body>

<body package="einfacheBsp" selector="runterschalten">runterschalten

	(gang &gt; 1)
		ifTrue: [
			gang := gang - 1
		]</body>

<body package="einfacheBsp" selector="bremsen">bremsen

	geschwindigkeit := geschwindigkeit * 0.9</body>

<body package="einfacheBsp" selector="raufschalten">raufschalten

	(gang &lt; anzahlGaenge)
		ifTrue: [
			gang := gang + 1
		]</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto</class-id> <category>initialize-release</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Initialisiert ein neu erzeugtes Objekt.
	 Alle Attribute (ausgenommen Besitzer) werden mit fixen Werten initialisiert.
	 Es wird eine Anfangsgeschwindigkeit von 10 km/h angenommen."

	super initialize.
	self besitzer: nil.
	self farbe: 'rot'.
	self anzahlGaenge: 5.
	self geschwindigkeit: 10.0.
	self gang: 1.
	^ self</body>
</methods>



<component-created>
<name>organisation</name> <type>package</type>
</component-created><!-- Package organisation* -->


<component-property>
<name>organisation</name> <type>package</type>
<property>prerequisiteParcels</property> <value>#(#('Base VisualWorks' ''))</value>
</component-property>

<component-property>
<name>organisation</name> <type>package</type>
<property>developmentPrerequisites</property> <value>#(#(#any 'Base VisualWorks' ''))</value>
</component-property>

<component-property>
<name>organisation</name> <type>package</type>
<property>prerequisiteDescriptions</property> <value>#(#(#name 'Base VisualWorks' #componentType #bundle))</value>
</component-property>

<component-property>
<name>organisation</name> <type>package</type>
<property>comment</property> <value>'Paket für die Smalltalk-Beispielklassen des Beispiels "Personen - Mitarbeiter - Organisationen" von Kapitel 4.4 aus dem Buch "Objektorientierte Programmierung" von Beringer Alfred.
Beinhaltet die Klassen ''Person'', ''Kunde'', ''Mitarbeiter'', ''Manager'', ''Organisation'' , ''Abteilung'' und ''Projekt'' aus dem Buch.
'</value>
</component-property>

<class>
<name>Person</name>
<environment>BeringerOrganisation</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>name geburtsdatum geschlecht adresse </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Beispiel Organisation</category>
<attributes>
<package>organisation</package>
</attributes>
</class>

<comment>
<class-id>BeringerOrganisation.Person</class-id>
<body>Instanzen dieser Klasse repräsentieren natürliche Personen.

Class Variables
	MAENNLICH					&lt;Character&gt;		Kennzeichen für männliches Geschlecht
	WEIBLICH					&lt;Character&gt;		Kennzeichen für weibliches Geschlecht
	ANREDEMAENNLICH		&lt;String&gt;			Anrede für Personen männlichen Geschlechts
	ANREDEWEIBLICH		&lt;String&gt;			Anrede für Personen weiblichen Geschlechts

Instance Variables
	name			&lt;String&gt;			Name
	gebDatum	&lt;Date&gt;			Geburtsdatum
	geschlecht	&lt;Character&gt;		Kennzeichen für Geschlecht (M = männlich, W = weiblich = W)
	adresse		&lt;String&gt;			Adresse


**************************************
"PersonTesten"

"Anlegen einer Person"

	Person new.			"nicht erlaubt!"

"Pflege der Personendaten"

	| p1 p2 |

	p1 := Person newName: 'Dr. Karl Huber'
		     gebDatum: (Date readFromString:'07/13/1962')
		     geschlecht: $M.
	p1.				"&lt;Print it&gt; ... Person: Dr. Karl Huber (July 13, 1962) " 
	p2 := Person newGebDatum: (Date readFromString:'07/13/1977') geschlecht: $M.
	p2 name: 'Hugo'.
	p2.

"Berechne das Alter von Huber"

	p1 alterBerechnen.		"&lt;Print it&gt; ... 50 "
</body>
</comment>

<class>
<name>Mitarbeiter</name>
<environment>BeringerOrganisation</environment>
<super>BeringerOrganisation.Person</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>persNr stellung grundgehalt organisation </inst-vars>
<class-inst-vars>MaxGehalt </class-inst-vars>
<imports></imports>
<category>Beispiel Organisation</category>
<attributes>
<package>organisation</package>
</attributes>
</class>

<comment>
<class-id>BeringerOrganisation.Mitarbeiter</class-id>
<body>Jede Instanz dieser Klasse repräsentiert eine Mitarbeiterin bzw. einen Mitarbeiter.

Class Variables
	LetztePersNr		&lt;Integer&gt;		zuletzt vergebene Personalnummer

Class Instance Variables
	MaxGehalt			&lt;Float&gt;			monatliches Maximalgehalt ohne Zuschläge


Instance Variables
	persNr			&lt;Integer&gt;			unternehmensweit eindeutige Personalnummer
	stellung			&lt;String&gt;			Funktion bzw. Position, die eine Mitarbeiterin bzw. ein Mitarbeiter im Unternehmen hat
	grundgehalt		&lt;Float&gt;				monatliches Gehalt ohne Zuschläge
	organisation		&lt;Organisation&gt;		Abteilung oder Projekt, in der bzw. in dem eine Mitarbeiterin bzw. ein Mitarbeiter arbeitet
</body>
</comment>

<class>
<name>Organisation</name>
<environment>BeringerOrganisation</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>name leiter mitarbeiterliste sachkosten </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Beispiel Organisation</category>
<attributes>
<package>organisation</package>
</attributes>
</class>

<comment>
<class-id>BeringerOrganisation.Organisation</class-id>
<body>Abstrakte Klasse für organisatorische Einheiten in einem Unternehmen.
Organisatorische Einheiten können Abteilungen, Projekte usw. sein.

Instance Variables
	name			&lt;String&gt;				Name der Organisation
	leiter			&lt;Manager&gt;				Leiter/Leiterin der Organisation
	mitarbeiterliste	&lt;Set of Mitarbeiter&gt;		Mitarbeiterliste
	sachkosten		&lt;Float&gt;					Sachkosten

****************************************************************************
"Anwendungsprogramm für Beispiel Personen-Mitarbeiter-Organisation"

| mita11 mita12 mita2 mitp1 mitp21 mitp22 
  mana1  mana2  manp1 manp2
  abt1   abt2
  proj1  proj2 |

Mitarbeiter initialize.

abt1 := Abteilung new.
abt1 name: 'Abt1';
     einnahmen: 200000;
     sachkosten: 7000.

abt2 := Abteilung new.
abt2 name: 'Abt2';
     einnahmen: 350000.

proj1 := Projekt new.
proj1 name: 'Projekt1'.

proj2 := Projekt new.
proj2 name: 'Projekt2';
      sachkosten: 5500;
      planZeit: 2;
      planJahresgewinn: 600000;
      planLebensdauer: 6.

"mita11 := Mitarbeiter new.		***error*** geht nicht"
mita11 := Mitarbeiter newGeburtsdatum: (Date readFromString:'07/17/1962') geschlecht: $M.
mita11 name: 'Huber Hans'.
mita11 grundgehalt: 2100;
       organisation: abt1.

mita12 := Mitarbeiter newGeburtsdatum: (Date readFromString:'01/13/1977') geschlecht: $W.
mita12 name: 'Irene Gross'.
mita12 grundgehalt: 2500;
       organisation: abt1.

mita2 := Mitarbeiter newName: 'Karli' geburtsdatum: (Date today) geschlecht: $M.
mita2 organisation: abt2.

mitp1 := Mitarbeiter newName: 'Doris' geburtsdatum: (Date today) geschlecht: $W.
mitp1 organisation: proj1.

mitp21 := Mitarbeiter newName: 'Hansi' geburtsdatum: (Date today) geschlecht: $M.
mitp21 organisation: proj2.

mitp22 := Mitarbeiter newName: 'Helga' geburtsdatum: (Date today) geschlecht: $W.
mitp22 organisation: proj2.

mana1 := Manager newName: 'Klammer Franz' geburtsdatum: (Date today) geschlecht: $M.
mana1 grundgehalt: 5500;
      organisation: abt1;
      geleiteteOrganisation: abt1.

mana2 := Manager newName: 'Muster Tom' geburtsdatum: (Date today) geschlecht: $M.
mana2 organisation: abt2;
      geleiteteOrganisation: abt2.

manp1 := Manager newName: 'Toni' geburtsdatum: (Date today) geschlecht: $M.
manp1 organisation: proj1;
      geleiteteOrganisation: proj1.

manp2 := Manager newName: 'Annemarie' geburtsdatum: (Date today) geschlecht: $W.
manp2 grundgehalt: 4700;
      organisation: proj2;
      geleiteteOrganisation: proj2.

Transcript clear; show: 'Personalnummern: ' , 
                                     mita11 persNr printString , ' ' , mita12 persNr printString , ' ' ,
                                     mita2 persNr printString  , ' ' , mitp1 persNr printString  , ' ' ,
                                     mitp21 persNr printString , ' ' , mitp22 persNr printString , ' ' ,
                                     mana1 persNr printString  , ' ' , mana2 persNr printString  , ' ' ,
                                     manp1 persNr printString  , ' ' , manp2 persNr printString.

Transcript cr; show: mita12 anrede printString.
Transcript cr; show: mana1 anrede printString.

Transcript cr; show: mita11 alterBerechnen printString.
Transcript cr; show: mita12 alterBerechnen printString.

Transcript cr; show: mita11 verdient printString.
Transcript cr; show: mana1 verdient printString.
Transcript cr; show: manp2 verdient printString.

abt1 druckeAlleMitarbeiter.     Transcript cr.
abt2 druckeAlleMitarbeiter.     Transcript cr.
proj1 druckeAlleMitarbeiter.    Transcript cr.
proj2 druckeAlleMitarbeiter.    Transcript cr.

abt1 druckeKostenUebersicht.    Transcript cr.
proj2 druckeKostenUebersicht.   Transcript cr.
</body>
</comment>

<class>
<name>Abteilung</name>
<environment>BeringerOrganisation</environment>
<super>BeringerOrganisation.Organisation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>einnahmen </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Beispiel Organisation</category>
<attributes>
<package>organisation</package>
</attributes>
</class>

<comment>
<class-id>BeringerOrganisation.Abteilung</class-id>
<body>Instanzen repräsentieren Abteilungen (als spezielle organisatorische Einheiten) in einem Unternehmen.

Instance Variables
	einnahmen	&lt;Float&gt;		Einnahmen
</body>
</comment>

<class>
<name>Manager</name>
<environment>BeringerOrganisation</environment>
<super>BeringerOrganisation.Mitarbeiter</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>geleiteteOrganisation </inst-vars>
<class-inst-vars>Gewinnanteil </class-inst-vars>
<imports></imports>
<category>Beispiel Organisation</category>
<attributes>
<package>organisation</package>
</attributes>
</class>

<comment>
<class-id>BeringerOrganisation.Manager</class-id>
<body>Instanzen dieser Klasse repräsentieren Personen, die Abteilungen oder Projekte leiten.

Class Instance Variables
	Gewinnanteil		&lt;Float&gt;		Gewinnanteil am Gewinn der geleiteten Abteilung bzw. des geleiteten Projekts


Instance Variables
	geleiteteOrganisation	&lt;Organisation&gt;	 geleitete Organisation (Abteilung oder Projekt)
</body>
</comment>

<class>
<name>Projekt</name>
<environment>BeringerOrganisation</environment>
<super>BeringerOrganisation.Organisation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>planZeit planJahresgewinn planLebensdauer </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Beispiel Organisation</category>
<attributes>
<package>organisation</package>
</attributes>
</class>

<comment>
<class-id>BeringerOrganisation.Projekt</class-id>
<body>Instanzen repräsentieren Projekte (als spezielle organisatorische Einheiten) in einem Unternehmen.

Instance Variables
	planZeit				&lt;Integer&gt;		geplante Zeit
	planJahresgewinn	&lt;Float&gt;		geplanter Jahresgewinn
	planLebensdauer	&lt;Integer&gt;		geplante Lebensdauer
</body>
</comment>

<class>
<name>Kunde</name>
<environment>BeringerOrganisation</environment>
<super>BeringerOrganisation.Person</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>jahresumsatz kreditlimit </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Beispiel Organisation</category>
<attributes>
<package>organisation</package>
</attributes>
</class>

<comment>
<class-id>BeringerOrganisation.Kunde</class-id>
<body>Instanzen dieser Klasse repräsentieren Kunden.

Instance Variables
	jahresumsatz		&lt;Float&gt;		Jahresumsatz
	kreditlimit			&lt;Float&gt;		Kreditlimit
</body>
</comment>

<shared-variable>
<name>ANREDEMAENNLICH</name>
<environment>BeringerOrganisation.Person</environment>
<private>false</private>
<constant>false</constant>
<category>Klassenvariable</category>
<attributes>
<package>organisation</package>
</attributes>
</shared-variable>


<shared-variable>
<name>ANREDEWEIBLICH</name>
<environment>BeringerOrganisation.Person</environment>
<private>false</private>
<constant>false</constant>
<category>Klassenvariable</category>
<attributes>
<package>organisation</package>
</attributes>
</shared-variable>


<shared-variable>
<name>MAENNLICH</name>
<environment>BeringerOrganisation.Person</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>$M</initializer>
<attributes>
<package>organisation</package>
</attributes>
</shared-variable>


<shared-variable>
<name>WEIBLICH</name>
<environment>BeringerOrganisation.Person</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>$W</initializer>
<attributes>
<package>organisation</package>
</attributes>
</shared-variable>



<shared-variable>
<name>LetztePersNr</name>
<environment>BeringerOrganisation.Mitarbeiter</environment>
<private>true</private>
<constant>false</constant>
<category>Klassenvariable</category>
<initializer>0</initializer>
<attributes>
<package>organisation</package>
</attributes>
</shared-variable>



<methods>
<class-id>BeringerOrganisation.Organisation</class-id> <category>accessing</category>

<body package="organisation" selector="removeMitarbeiter:">removeMitarbeiter: einMitarbeiter

	mitarbeiterliste remove: einMitarbeiter
		ifAbsent: [
			Transcript  cr;  show: 'Mitarbeiter wurde bereits entfernt'
		]</body>

<body package="organisation" selector="mitarbeiterliste">mitarbeiterliste

	^ mitarbeiterliste</body>

<body package="organisation" selector="name:">name: neuerName

	name := neuerName</body>

<body package="organisation" selector="leiter:">leiter: einManager

	leiter := einManager</body>

<body package="organisation" selector="leiter">leiter

	^ leiter</body>

<body package="organisation" selector="sachkosten:">sachkosten: eineZahl

	sachkosten := eineZahl</body>

<body package="organisation" selector="name">name

	^ name</body>

<body package="organisation" selector="addMitarbeiter:">addMitarbeiter: einMitarbeiter
	"Fügt einen neuen Mitarbeiter hinzu; wird gegebenenfalls aus seiner vorhergehenden Organisation entfernt."

	| bisherigeOrg |

	bisherigeOrg := einMitarbeiter organisation.
	(bisherigeOrg ~= self)
		ifTrue: [
			(bisherigeOrg notNil)
				ifTrue: [
					bisherigeOrg removeMitarbeiter: einMitarbeiter
				].
			einMitarbeiter organisation: self
		].
	mitarbeiterliste add: einMitarbeiter</body>

<body package="organisation" selector="sachkosten">sachkosten

	^ sachkosten</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Organisation</class-id> <category>printing</category>

<body package="organisation" selector="druckeKostenUebersicht">druckeKostenUebersicht
	"Erstellt eine Übersichtsliste der Gesamtkosten der Organisation."

	Transcript  cr;  show: self class name , ': ' , self name , '   Kostenübersicht';
				  cr;  show: '------------------------------------------------------------'.
	Transcript  cr;  show: 'Mitarbeiter';  tab;  	tab;  tab;  	tab;  show: 'Grundgehalt';  tab;  show: 'Verdienst';
				  cr;  show: '------------------------------------------------------------'.
	mitarbeiterliste do: [ :ma |
			Transcript  cr;  show: ma anrede;  tab;  tab;  show: ma grundgehalt printString;  tab;  show: ma verdient printString
		].
	Transcript  cr;  show: '------------------------------------------------------------';
				  cr;  show: 'Personalkosten = ';	tab;  show: self personalkosten printString;
				  cr;  show: 'Prämie =         ';		tab;  show: self praemie printString;
				  cr;  show: 'Sachkosten =     ';	tab;  show: self sachkosten printString;
				  cr;  show: 'Gesamtkosten =   ';	tab;  show: self gesamtkosten printString;
				  cr;  show: 'Gewinn =         ';		tab;  show: self gewinn printString</body>

<body package="organisation" selector="druckeAlleMitarbeiter">druckeAlleMitarbeiter
	"Erstellt eine Übersichtsliste aller Mitarbeiter + Leiter der Organisation."

	Transcript  cr;  show: self class name , ': ' , self name.
	(self leiter isNil)
		ifTrue: [
			Transcript  cr;  show: 'noch kein Leiter ernannt.'
		]
		ifFalse: [
			Transcript  cr;  show: 'geleitet von: ' , self leiter name
		].
	Transcript  cr;  show: 'Anzahl Mitarbeiter = ' , mitarbeiterliste size printString.
	mitarbeiterliste do: [ :ma |
			Transcript  cr;  show: ma anrede , ' (Grundgehalt = ' , ma grundgehalt printString , ')'
		]</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Organisation</class-id> <category>berechnungen</category>

<body package="organisation" selector="gesamtkosten">gesamtkosten
	"Berechnet die Gesamtkosten (einschließlich der Prämien der Manager)."

	^ self gesamtkostenOhnePraemie + self praemie</body>

<body package="organisation" selector="personalkostenOhnePraemie">personalkostenOhnePraemie
	"Berechnet die Personalkosten aus den Grundgehältern der Mitarbeiter."

	| summe |

	summe := 0.
	mitarbeiterliste do: [ :ma |
			summe := summe + ma grundgehalt
		].
	^ summe</body>

<body package="organisation" selector="personalkosten">personalkosten
	"Berechnet die Personalkosten aus den Grundgehältern + Prämien der Manager."

	^ self personalkostenOhnePraemie + self praemie</body>

<body package="organisation" selector="gewinnOhnePraemie">gewinnOhnePraemie
	"Abstrakte Methode.
	 Berechnet den Gewinn der Organisation (zur Bestimmung des Gewinnanteils).
	 Dieser ist abhängig von der Art der Organisation (Abteilung oder Projekt)."

	self subclassResponsibility</body>

<body package="organisation" selector="gewinn">gewinn
	"Berechnet den Gewinn der Organisation (ohne Prämien der Manager)."

	^ self gewinnOhnePraemie - self praemie</body>

<body package="organisation" selector="gesamtkostenOhnePraemie">gesamtkostenOhnePraemie
	"Berechnet die Gesamtkosten (= Personalkosten + Sachkosten)."

	^ self personalkostenOhnePraemie + self sachkosten</body>

<body package="organisation" selector="praemie">praemie
	"Berechnet die Prämie des Leiters bzw. der Leiterin der Organisation."

	^ self gewinnOhnePraemie * Manager gewinnanteil</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Organisation</class-id> <category>initialize-release</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert eine neu erstellte Instanz."

	super initialize.
	mitarbeiterliste := Set new.
	self sachkosten: 0.
	^ self</body>
</methods>


<methods>
<class-id>BeringerOrganisation.Abteilung class</class-id> <category>instance creation</category>

<body package="organisation" selector="new">new

	^ super new initialize</body>
</methods>


<methods>
<class-id>BeringerOrganisation.Abteilung</class-id> <category>initialize-release</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert eine neu erstellte Instanz."

	super initialize.
	self einnahmen: 0.
	^ self</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Abteilung</class-id> <category>accessing</category>

<body package="organisation" selector="einnahmen">einnahmen

	^ einnahmen</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Abteilung</class-id> <category>berechnungen</category>

<body package="organisation" selector="addiereZuEinnahmen:">addiereZuEinnahmen: eineZahl
	"Einnahmen werden erhöht"

	self einnahmen: self einnahmen + eineZahl</body>

<body package="organisation" selector="gewinnOhnePraemie">gewinnOhnePraemie
	"Liefert den Bruttogewinn des Empfängers"

	^ self einnahmen - self gesamtkostenOhnePraemie</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Abteilung</class-id> <category>private</category>

<body package="organisation" selector="einnahmen:">einnahmen: eineZahl
	"Simuliert Setzen der Einnahmen.
	 Diese Set-Methode dient nur zum Testen (Einnahmen ergeben sich ja nur aus anderen Methoden wie überweisen, verkaufen o.ä.)."

	einnahmen := eineZahl</body>
</methods>


<methods>
<class-id>BeringerOrganisation.Person class</class-id> <category>class initialization</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert Klassenvariable und/oder Klasseninstanzvariable."

	ANREDEMAENNLICH := 'Herr'.
	ANREDEWEIBLICH := 'Frau'</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Person class</class-id> <category>instance creation</category>

<body package="organisation" selector="newName:geburtsdatum:geschlecht:">newName: einName geburtsdatum: einDatum geschlecht: kennzGeschlecht
	"Anlegen einer Personeninstanz mit Name, Geburtsdatum und Geschlecht."

	^ self
		newName: einName
		geburtsdatum: einDatum
		geschlecht: kennzGeschlecht
		adresse: ''</body>

<body package="organisation" selector="newGeburtsdatum:geschlecht:">newGeburtsdatum: einDatum geschlecht: kennzGeschlecht
	"Anlegen einer Personeninstanz mit Geburtsdatum und Geschlecht."

	^ self
		newName: ''
		geburtsdatum: einDatum
		geschlecht: kennzGeschlecht
		adresse: ''</body>

<body package="organisation" selector="newName:geburtsdatum:geschlecht:adresse:">newName: einName geburtsdatum: einDatum geschlecht: kennzGeschlecht adresse: eineAdresse
	"Anlegen einer Personeninstanz mit allen Attributen."

	^ (super new)
		name: einName;
		geburtsdatum: einDatum;
		geschlecht: kennzGeschlecht;
		adresse: eineAdresse;
		initialize</body>

<body package="organisation" selector="new">new
	"Eine Personeninstanz kann nur mit Geburtsdatum und Geschlecht erzeugt werden."

	self error: 'Keine Daten (mindestens Geburtsdatum und Geschlecht sind anzugeben)'</body>
</methods>


<methods>
<class-id>BeringerOrganisation.Person</class-id> <category>initialize-release</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert eine neu erstellte Instanz.
	 Kann in Subklassen überschrieben werden."

	super initialize.
	^ self</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Person</class-id> <category>accessing</category>

<body package="organisation" selector="adresse">adresse

	^ adresse</body>

<body package="organisation" selector="name:">name: neuerName

	name := neuerName</body>

<body package="organisation" selector="adresse:">adresse: neueAdresse

	adresse := neueAdresse</body>

<body package="organisation" selector="geschlecht">geschlecht

	^ geschlecht</body>

<body package="organisation" selector="name">name

	^ name</body>

<body package="organisation" selector="geburtsdatum">geburtsdatum

	^ geburtsdatum copy		"Achtung: Nur eine Kopie des Originalobjekts wird zurückgegeben!"</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Person</class-id> <category>berechnungen</category>

<body package="organisation" selector="anrede">anrede

	(self geschlecht = MAENNLICH)
		ifTrue: [
			^ ANREDEMAENNLICH
		].

	(self geschlecht = WEIBLICH)
		ifTrue: [
			^ ANREDEWEIBLICH
		].

	^ ''</body>

<body package="organisation" selector="alterBerechnen">alterBerechnen
	"liefert das Alter der Person in Anzahl von Jahren (ohne Berücksichtigung des Monats)"

	^ (Date today year - self geburtsdatum year)</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Person</class-id> <category>private</category>

<body package="organisation" selector="geschlecht:">geschlecht: kennzeichen

	geschlecht := kennzeichen.
	( kennzeichen = MAENNLICH or: [kennzeichen = WEIBLICH] )
		ifTrue: [
			^ true
		].

	"ungültiges Kennzeichen für Geschlecht!"
	^ false</body>

<body package="organisation" selector="geburtsdatum:">geburtsdatum: einDatum
	"Das neue Geburtsdatum muss vor dem aktuellen Tagesdatum liegen."

	( (einDatum class == Date) and: [einDatum &lt;= Date today] )
		ifTrue: [
			geburtsdatum := einDatum copy.			"Achtung: Nur Kopie des Parameterobjekts verwenden!"
			^ true
		].

	"ungültiges Geburtsdatum"
	geburtsdatum := Date today.					
	^ false</body>
</methods>


<methods>
<class-id>BeringerOrganisation.Mitarbeiter class</class-id> <category>class initialization</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert Klassenvariable und/oder Klasseninstanzvariable."

	Mitarbeiter letztePersNr: 0.
	Mitarbeiter maxGehalt: 4500</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Mitarbeiter class</class-id> <category>accessing</category>

<body package="organisation" selector="maxGehalt:">maxGehalt: eineZahl

	MaxGehalt := eineZahl</body>

<body package="organisation" selector="letztePersNr">letztePersNr

	^ LetztePersNr</body>

<body package="organisation" selector="maxGehalt">maxGehalt

	^ MaxGehalt</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Mitarbeiter class</class-id> <category>private</category>

<body package="organisation" selector="letztePersNr:">letztePersNr: eineZahl

	LetztePersNr := eineZahl</body>
</methods>


<methods>
<class-id>BeringerOrganisation.Mitarbeiter</class-id> <category>private</category>

<body package="organisation" selector="persNrNeu">persNrNeu
	"Ordnet jedem Mitarbeiter eine unternehmensweit eindeutige (fortlaufende) Personalnummer zu."

	(persNr isNil)
		ifTrue: [
			self class letztePersNr: (self class letztePersNr + 1).
			persNr := self class letztePersNr.
			^ true
		].

	self error: ' Mitarbeiter hat bereits eine Personalnummer!'.
	^ false</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Mitarbeiter</class-id> <category>accessing</category>

<body package="organisation" selector="persNr">persNr

	^ persNr</body>

<body package="organisation" selector="organisation:">organisation: eineOrganisation
	"Ändert die Organisation des Mitarbeiters und fügt ihn in die neue Organisation ein, falls er dieser noch nicht angehört."

	(eineOrganisation isKindOf: Organisation)
		ifTrue: [
			(self organisation notNil)
				ifTrue: [
					self organisation removeMitarbeiter: self
				].
			organisation := eineOrganisation.
			organisation addMitarbeiter: self
		]
		ifFalse: [
			(eineOrganisation isNil)
				ifTrue: [
					(self organisation notNil)
						ifTrue: [
							self organisation removeMitarbeiter: self
						].
					organisation := eineOrganisation
				]
				ifFalse: [
					self error: eineOrganisation class name , ' ist keine gültige Organisation'
				]
		]</body>

<body package="organisation" selector="organisation">organisation

	^ organisation</body>

<body package="organisation" selector="grundgehalt:">grundgehalt: eineZahl
	"Ändert das Grundgehalt des Mitarbeiters (soferne es nicht größer als das maximale Gehalt ist)."

	(eineZahl &lt;= self class maxGehalt)
		ifTrue: [
			grundgehalt := eineZahl.
			^ true
		].

	self error: 'Grundgehalt von ' , self class name , ' kann maximal sein: ' , self class maxGehalt printString.
	^ false</body>

<body package="organisation" selector="stellung:">stellung: neueStellung

	stellung := neueStellung</body>

<body package="organisation" selector="grundgehalt">grundgehalt

	^ grundgehalt</body>

<body package="organisation" selector="stellung">stellung

	^ stellung</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Mitarbeiter</class-id> <category>berechnungen</category>

<body package="organisation" selector="anrede">anrede

	^ super anrede , ' ' , self stellung , ' ' , self name</body>

<body package="organisation" selector="verdient">verdient

	^ self grundgehalt</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Mitarbeiter</class-id> <category>initialize-release</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert eine neu erstellte Instanz.
	 Die Bezeichnung der Stellung ist der Einfachheit halber nicht geschlechtsneutral."

	super initialize.
	self
		persNrNeu;
		stellung: 'Mitarbeiter';
		grundgehalt: 1200;
		organisation: nil.
	^ self</body>
</methods>


<methods>
<class-id>BeringerOrganisation.Manager class</class-id> <category>class initialization</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert Klassenvariable und/oder Klasseninstanzvariable."

	Manager maxGehalt: 15000.
	Manager gewinnanteil: 0.05</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Manager class</class-id> <category>accessing</category>

<body package="organisation" selector="gewinnanteil:">gewinnanteil: eineZahl

	Gewinnanteil := eineZahl</body>

<body package="organisation" selector="gewinnanteil">gewinnanteil

	^ Gewinnanteil</body>
</methods>


<methods>
<class-id>BeringerOrganisation.Manager</class-id> <category>accessing</category>

<body package="organisation" selector="geleiteteOrganisation">geleiteteOrganisation

	^ geleiteteOrganisation</body>

<body package="organisation" selector="geleiteteOrganisation:">geleiteteOrganisation: eineOrganisation
	"Ändert die vom Manager geleitete Organisation, ändert gegebenenfalls seinen Status in der Organisation."

	(eineOrganisation isKindOf: Organisation)
		ifTrue: [
			self organisation: eineOrganisation.
			geleiteteOrganisation := eineOrganisation.
			geleiteteOrganisation leiter: self.
			^ true
		].

	self error: eineOrganisation class name , 'ist ungültige Organisation'.
	^ false</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Manager</class-id> <category>berechnungen</category>

<body package="organisation" selector="verdient">verdient

	^ self grundgehalt + (geleiteteOrganisation gewinnOhnePraemie * self class gewinnanteil)</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Manager</class-id> <category>initialize-release</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert eine neu erstellte Instanz.
	 Die Bezeichnung der Stellung ist der Einfachheit halber nicht geschlechtsneutral."

	super initialize.
	self
		stellung: 'Leiter';
		grundgehalt: 5000.
	^ self</body>
</methods>


<methods>
<class-id>BeringerOrganisation.Projekt class</class-id> <category>instance creation</category>

<body package="organisation" selector="new">new

	^ super new initialize</body>
</methods>


<methods>
<class-id>BeringerOrganisation.Projekt</class-id> <category>accessing</category>

<body package="organisation" selector="planJahresgewinn:">planJahresgewinn: eineZahl

	planJahresgewinn := eineZahl</body>

<body package="organisation" selector="planZeit:">planZeit: anzahlJahre

	planZeit := anzahlJahre</body>

<body package="organisation" selector="planJahresgewinn">planJahresgewinn

	^ planJahresgewinn</body>

<body package="organisation" selector="planZeit">planZeit

	^ planZeit</body>

<body package="organisation" selector="planLebensdauer:">planLebensdauer: anzahlJahre

	planLebensdauer := anzahlJahre</body>

<body package="organisation" selector="planLebensdauer">planLebensdauer

	^ planLebensdauer</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Projekt</class-id> <category>berechnungen</category>

<body package="organisation" selector="gewinnOhnePraemie">gewinnOhnePraemie
	"Liefert den Bruttogewinn des Empfängers (pro Monat)"

	^ (planJahresgewinn * planLebensdauer) / (planZeit * 12) - self gesamtkostenOhnePraemie</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Projekt</class-id> <category>initialize-release</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert eine neu erstellte Instanz."

	super initialize.
	self
		planZeit: 1;
		planJahresgewinn: 0;
		planLebensdauer: 0.
	^ self</body>
</methods>


<methods>
<class-id>BeringerOrganisation.Kunde</class-id> <category>initialize-release</category>

<body package="organisation" selector="initialize">initialize

	super initialize.
	self jahresumsatz: 0.
	self kreditlimit: 0.
	^ self</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Kunde</class-id> <category>accessing</category>

<body package="organisation" selector="jahresumsatz">jahresumsatz

	^ jahresumsatz</body>

<body package="organisation" selector="jahresumsatz:">jahresumsatz: eineZahl

	jahresumsatz := eineZahl</body>

<body package="organisation" selector="kreditlimit:">kreditlimit: eineZahl

	kreditlimit := eineZahl</body>

<body package="organisation" selector="kreditlimit">kreditlimit

	^ kreditlimit</body>
</methods>



<bundle-structure>
<name>oopBuch</name> <structure>#(#(#package 'namespaces') #(#package 'einfacheBsp') #(#package 'organisation'))</structure>
</bundle-structure>

<initialize>
<variable-id>BeringerEinfacheBsp.Datum.LfdTagMonatsanfang</variable-id>
</initialize>

<initialize>
<variable-id>BeringerEinfacheBsp.Datum.Monatsnamen</variable-id>
</initialize>

<initialize>
<variable-id>BeringerEinfacheBsp.Datum.TageProMonat</variable-id>
</initialize>

<initialize>
<variable-id>BeringerEinfacheBsp.Person.MAENNLICH</variable-id>
</initialize>

<initialize>
<variable-id>BeringerEinfacheBsp.Person.WEIBLICH</variable-id>
</initialize>

<initialize>
<class-id>BeringerEinfacheBsp.Auto</class-id>
</initialize>

<initialize>
<class-id>BeringerEinfacheBsp.Zaehler3</class-id>
</initialize>

<initialize>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id>
</initialize>

<initialize>
<variable-id>BeringerOrganisation.Person.MAENNLICH</variable-id>
</initialize>

<initialize>
<variable-id>BeringerOrganisation.Person.WEIBLICH</variable-id>
</initialize>

<initialize>
<variable-id>BeringerOrganisation.Mitarbeiter.LetztePersNr</variable-id>
</initialize>

<initialize>
<class-id>BeringerOrganisation.Manager</class-id>
</initialize>

<initialize>
<class-id>BeringerOrganisation.Person</class-id>
</initialize>

<initialize>
<class-id>BeringerOrganisation.Mitarbeiter</class-id>
</initialize>

</st-source>
