<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® Personal Use Edition, 7.10.1 of 06. Februar 2014 on 31. Mai 2014 at 12:11:14</time-stamp>


<component-created>
<name>einfacheBsp</name> <type>package</type>
</component-created><!-- Package einfacheBsp* -->


<component-property>
<name>einfacheBsp</name> <type>package</type>
<property>prerequisiteParcels</property> <value>#(#('Base VisualWorks' ''))</value>
</component-property>

<component-property>
<name>einfacheBsp</name> <type>package</type>
<property>developmentPrerequisites</property> <value>#(#(#any 'Base VisualWorks' ''))</value>
</component-property>

<component-property>
<name>einfacheBsp</name> <type>package</type>
<property>prerequisiteDescriptions</property> <value>#(#(#name 'Base VisualWorks' #componentType #bundle))</value>
</component-property>

<component-property>
<name>einfacheBsp</name> <type>package</type>
<property>comment</property> <value>'Paket für die Smalltalk-Beispielklassen von Kapitel 2 aus dem Buch "Objektorientierte Programmierung" von Beringer Alfred.
Beinhaltet die Klassen ''Person'', ''Auto'', ''Zaehler'', ''Zaehler2'' und ''Datum'' aus dem Buch. Zusätzlich enthält es noch die Klasse ''Zaehler3''.
'</value>
</component-property>

<class>
<name>Person</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>vorname geburtsjahr geschlecht </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<comment>
<class-id>BeringerEinfacheBsp.Person</class-id>
<body>Eine einfache Personen-Klasse.
Jede Instanz dieser Klasse repräsentiert eine natürliche Person.
Klassenkonstante für gültige Geschlechtskennzeichen.
- Jede Person hat immer ein Geburtsjahr und ein Geschlecht.
- Geburtsjahr und Geschlecht können nicht geändert werden.
- Geburtsjahr und Geschlecht werden geprüft:
- Geburtsjahr darf nicht größer sein als das laufende Jahr, das Geschlecht darf nur 'M' oder 'W' sein.
Es wurde zusätzlich noch die Methode 'printOn:' überschrieben.

Hinweis: Die Namen der Standardzugriffsmethoden entsprechen NICHT den üblichen 
         Smalltalk- bzw. UML-Konventionen ('attribut' bzw. 'attribut:'). 

Class Variables
	MAENNLICH	&lt;Character&gt;	Kennzeichen für männliches Geschlecht
	WEIBLICH		&lt;Character&gt;	Kennzeichen für weibliches Geschlecht

Instance Variables
	vorname		&lt;String&gt;		Vorname
	geburtsjahr		&lt;Integer&gt;		Geburtsjahr
	geschlecht		&lt;Character&gt;	Geschlecht
</body>
</comment>

<class>
<name>Datum</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>jj mm tt </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<comment>
<class-id>BeringerEinfacheBsp.Datum</class-id>
<body>Eine einfache Datumsklasse.

Class Variables
	Monatsnamen			&lt;String-Array&gt;		Monatsnamen
	TageProMonat			&lt;Integer-Array&gt;		Anzahl der Tage jedes Monats
	LfdTagMonatsanfang		&lt;String-Array&gt;		Laufende Tageszahl am 1. jedes Monats


Instance Variables
	jj		&lt;Integer&gt;		Jahr
	mm		&lt;Integer&gt;		Monat
	tt		&lt;Integer&gt;		Tag

**************************************
"DatumTesten"

| dat1 dat2 dat3 |

dat1 := Datum newJahr: 1988 monatsnummer: 2 tag:17.
dat1 istSchaltjahr.			"&lt;Print it&gt; liefert true"
dat1 lfdTagDesJahres.		"&lt;Print it&gt; liefert 48"
dat1.						"&lt;Print it&gt; liefert 17. 2. 1988"
dat2 := Datum heute.
dat2 istSchaltjahr.
dat2 lfdTagDesJahres.
dat3 := Datum new.
dat3 istSchaltjahr.
dat3 lfdTagDesJahres.

"--------------------------------------"

| jj today dat |

jj := 2000.
today := Datum heute.
dat := Datum newJahr: 1950 monatsnummer: 4 tag:25.

Datum istSchaltjahr: jj.			"&lt;Print it&gt; liefert true"

Transcript show: 'today = ';
               show: today tt printString; show: '.';
               show: today mm printString; show: '.';
               show: today jj printString; cr.
today istSchaltjahr.
today lfdTagDesJahres.

Transcript clear.
Transcript show: 'dat = ';
               show: dat tt printString; show: '.';
               show: dat mm printString; show: '.';
               show: dat jj printString; cr.

Transcript show: 'heutiger Tag = ';
               show: Datum heute tt printString; cr;
               show: 'heutiger Monat = ';
               show: Datum heute monatsname printString; cr;
               show: 'aktuelles Jahr = ';
               show: Datum heute jj printString; cr.
</body>
</comment>

<class>
<name>Auto</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>farbe anzahlGaenge geschwindigkeit gang besitzer </inst-vars>
<class-inst-vars>MwstSatz </class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<comment>
<class-id>BeringerEinfacheBsp.Auto</class-id>
<body>Eine sehr einfache Auto-Klasse, jede Instanz dieser Klasse repräsentiert ein Auto.
Jede Instanz wird mit einer Anfangsgeschwindigkeit von 10 km/h initialisiert.
Rauf- und runterschalten bewirkt keine Geschwindigkeitsänderung.
Bremsen und beschleunigen bewirkt immer eine Geschwindigkeitsänderung von 10%, jedoch keinen Gangwechsel.
Es wurde zusätzlich noch (neben der Methode 'zeigeInhalt') die Methode 'printOn:' überschrieben.

Class Instance Variables
	MwstSatz		&lt;Float&gt;	Mehrwertsteuersatz

Instance Variables
	besitzer				&lt;Person&gt;	Besitzer des Autos
	farbe					&lt;String&gt;		Farbe des Autos
	anzahlGaenge		&lt;Integer&gt;		Anzahl der Gänge
	gang					&lt;Integer&gt;		eingelegter Gang
	geschwindigkeit		&lt;Float&gt;		aktuelle Geschwindigkeit

**************************************
"AutoTesten"

| auto |

auto := Auto new.

auto besitzer: (BeringerEinfacheBsp.Person newGeburtsjahr: 1980  geschlecht: $M).
auto farbe: 'blau'.
auto raufschalten.
auto zeigeInhalt.

Auto mwstSatz: 20.
auto besitzer aendernVorname: 'Hugo'.
auto raufschalten.
auto raufschalten.
auto zeigeInhalt.

auto runterschalten.
auto beschleunigen.
auto zeigeInhalt.

auto bremsen.
auto zeigeInhalt.
</body>
</comment>

<class>
<name>Zaehler</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>wert </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<comment>
<class-id>BeringerEinfacheBsp.Zaehler</class-id>
<body>Instanzen dieser Klasse repräsentieren einen einfachen Zähler, der (um 1) erhöht und (auf 0) zurückgesetzt werden kann.

Instance Variables
	wert	&lt;Integer&gt;		aktueller Stand des Zählers

**************************************
"ZaehlerTesten"

| z |

z := Zaehler new.
z erhoehen.
z wert			"&lt;Print It&gt; liefert 1"
</body>
</comment>

<class>
<name>Zaehler2</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>wert </inst-vars>
<class-inst-vars>Endwert </class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<comment>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id>
<body>Instanzen dieser Klasse repräsentieren einen einfachen zweistelligen Zähler, der (um 1) erhöht und (auf 0) zurückgesetzt werden kann.
Der Zähler beginnt nach 99 (= Standardwert für Endwert) wieder bei 0, d.h. bei 100 erfolgt ein Überlauf.

Class Instance Variables
	Endwert	&lt;Integer&gt;		maximaler Wert des Zählers

Instance Variables
	wert	&lt;Integer&gt;		aktueller Stand des Zählers

**************************************
"Zaehler2Testen"

| z |

Transcript clear.

z := Zaehler2 new.
z erhoehen.
1 to: 3 do: [ :k |
	1 to: 80 do: [ :i |
		z erhoehen 
	].
	Transcript cr;
			show: z wert printString
]
</body>
</comment>

<class>
<name>Zaehler3</name>
<environment>BeringerEinfacheBsp</environment>
<super>BeringerEinfacheBsp.Zaehler</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars>Endwert </class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<comment>
<class-id>BeringerEinfacheBsp.Zaehler3</class-id>
<body>Beispielklasse für Vererbung - entspricht der Klasse 'Zaehler2'.
Erweiterung der Klasse 'Zaehler' mit einem Klassenattribut für den Endwert.

Class Instance Variables
	Endwert	&lt;Integer&gt;		maximaler Wert des Zählers

**************************************
"Zaehler3Testen"

| z |

Transcript clear.

z := Zaehler3 new.
z erhoehen.
1 to: 3 do: [ :k |
	1 to: 80 do: [ :i |
		z erhoehen 
	].
	Transcript cr;
			show: z wert printString
]
</body>
</comment>

<shared-variable>
<name>LfdTagMonatsanfang</name>
<environment>BeringerEinfacheBsp.Datum</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>#(1 32 60 91 121 152 182 213 244 274 305 335)</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>


<shared-variable>
<name>Monatsnamen</name>
<environment>BeringerEinfacheBsp.Datum</environment>
<private>false</private>
<constant>false</constant>
<category>Klassenvariable</category>
<initializer>#('Jänner' 'Februar' 'März' 'April' 'Mai' 'Juni' 'Juli' 'August' 'September' 'Oktober' 'November' 'Dezember' )</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>


<shared-variable>
<name>TageProMonat</name>
<environment>BeringerEinfacheBsp.Datum</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>#(31 28 31 30 31 30 31 31 30 31 30 31)</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>



<shared-variable>
<name>MAENNLICH</name>
<environment>BeringerEinfacheBsp.Person</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>$M</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>


<shared-variable>
<name>WEIBLICH</name>
<environment>BeringerEinfacheBsp.Person</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>$W</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>



<methods>
<class-id>BeringerEinfacheBsp.Zaehler class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="new">new
	"Standardkonstruktor.
	 Zähler wird zurückgesetzt."

	^ super new reset</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Zaehler</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="wert">wert

	^ wert</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="erhoehen">erhoehen
	"Erhöht den Zähler um 1."

	self wert: (self wert + 1).

	"Einfacher, aber mit weniger Datenkapselung:
		wert := wert + 1.		"

	^ self wert</body>

<body package="einfacheBsp" selector="reset">reset
	"Setzt den Zähler zurück auf 0.
	 Kein expliziter Rückgabewert - somit wird das Zaehler-Objekt selbst zurückgegeben (entspricht   ^self)."

	self wert: 0

	"Einfacher, aber mit weniger Datenkapselung:
		wert := 0			"</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler</class-id> <category>private</category>

<body package="einfacheBsp" selector="wert:">wert: neuerWert
	"Ändert den Wert des Zählers - es erfolgt jedoch keine Prüfung auf Plausibilität!"

	wert := neuerWert</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Zaehler2 class</class-id> <category>class initialization</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Klassenkonstruktor.
	 Für einen zweistelligen Zähler wird der Endwert auf 99 gesetzt."

	Endwert := 99</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2 class</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="endwert">endwert

	^ Endwert</body>

<body package="einfacheBsp" selector="endwert:">endwert: endwert
	"Definiert einen neuen Endwert für den Zähler - es erfolgt jedoch keine Prüfung auf Plausibilität!"

	Endwert := endwert</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2 class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="new">new
	"Standardkonstruktor.
	 Zähler wird zurückgesetzt."

	^ super new reset</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="wert">wert

	^ wert</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="reset">reset
	"Setzt den Zähler zurück auf 0.
	 Kein expliziter Rückgabewert - somit wird das Zaehler-Objekt selbst zurückgegeben (entspricht   ^self)."

	self wert: 0</body>

<body package="einfacheBsp" selector="erhoehen">erhoehen
	"Erhöht den Zähler um 1 - bei Überlauf wird Zähler zurückgesetzt."

	self wert: (self wert + 1).
	^ self wert</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id> <category>private</category>

<body package="einfacheBsp" selector="wert:">wert: neuerWert
	"Ändert den Wert des Zählers.
	 Der neue Wert muss zwischen 0 und Endwert liegen."

	wert := neuerWert.
	( (self wert &gt; self class endwert) or: [self wert &lt; 0] ) 
		ifTrue: [
			self reset
		]</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Zaehler3 class</class-id> <category>class initialization</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Klassenkonstruktor.
	 Für einen zweistelligen Zähler wird der Endwert auf 99 gesetzt."

	Endwert := 99</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler3 class</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="endwert">endwert

	^ Endwert</body>

<body package="einfacheBsp" selector="endwert:">endwert: endwert
	"Definiert einen neuen Endwert für den Zähler - es erfolgt keine Prüfung auf Plausibilität!"

	Endwert := endwert</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Zaehler3</class-id> <category>private</category>

<body package="einfacheBsp" selector="wert:">wert: neuerWert
	"Überschreibt die entsprechende 'Zaehler'-Methode.
	 Der neue Zählerwert wird nun auf Plausibilität geprüft: Er muss zwischen 0 und Endwert liegen."

	super wert: neuerWert.
	( (self wert &gt; self class endwert) or: [self wert &lt; 0] )
		ifTrue: [
			self reset
		]</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Person class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="newGeburtsjahr:geschlecht:">newGeburtsjahr: einJahr geschlecht: kennzeichen
	"Jede Person muss ein Geburtsjahr und ein Geschlecht haben.
	 Standardkonstruktor ist nicht erlaubt."

	^ (super new)
		aendernGeburtsjahr: einJahr;
		aendernGeschlecht: kennzeichen;
		initialize</body>

<body package="einfacheBsp" selector="new">new
	"Eine Personeninstanz kann nur mit Geburtsdatum und Geschlecht erzeugt werden."

	self
		error: 'Keine Daten (mindestens Geburtsdatum und Geschlecht sind anzugeben)'</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Person</class-id> <category>initialize-release</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Initialisiert ein neu erzeugtes Objekt."

	super initialize.
	^ self</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Person</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="geboren">geboren

	^ geburtsjahr</body>

<body package="einfacheBsp" selector="hatGeschlecht">hatGeschlecht

	^ geschlecht</body>

<body package="einfacheBsp" selector="aendernVorname:">aendernVorname: neuerVorname

	vorname := neuerVorname</body>

<body package="einfacheBsp" selector="heisst">heisst

	^ vorname</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Person</class-id> <category>printing</category>

<body package="einfacheBsp" selector="printOn:">printOn: aStream
	"Dient zur textuellen Darstellung einer Personeninstanz.
	 Ermöglicht der Methode 'printString' eine sinnvolle Ausgabe."

	aStream
		nextPutAll: self class name , ': ' , self heisst printString , ' (' , self geboren printString , ') '</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Person</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="alterBerechnen">alterBerechnen
	"Berechnet das Alter der Person. Date ist eine Standardklasse von VisualWorks."

	^ (Date today year - self geboren)</body>

<body package="einfacheBsp" selector="anrede">anrede
	"Liefert die Anrede für die Person (abhängig vom Geschlecht).
	 Die Anrede ist fix codiert und nicht variabel!"

	(self hatGeschlecht = MAENNLICH)
		ifTrue: [
			^ 'Sehr geehrter Herr'
		].

	^ 'Sehr geehrte Frau'</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Person</class-id> <category>private</category>

<body package="einfacheBsp" selector="aendernGeburtsjahr:">aendernGeburtsjahr: einJahr
	"Setzt das Geburtsjahr der Person.
	 Das Geburtsjahr wird auf Gültigkeit geprüft:   (Geburtsjahr &lt;= laufendes Jahr).
	 Bei einem Fehler wird das Geburtsjahr nicht gesetzt!"

	( einJahr &lt;= Date today year )
		ifTrue: [
			geburtsjahr := einJahr.
			^ true
		].

	"ungültiges Geburtsjahr"
	^ false</body>

<body package="einfacheBsp" selector="aendernGeschlecht:">aendernGeschlecht: kennzeichen
	"Setzt das Geschlecht der Person.
	 Das Geschlecht wird auf Gültigkeit geprüft.
	 Bei einem Fehler wird das Geschlecht nicht gesetzt!"

	( (kennzeichen = MAENNLICH) or: [kennzeichen = WEIBLICH] )
		ifTrue: [
			geschlecht := kennzeichen.
			^ true
		].

	"ungültiges Kennzeichen für Geschlecht"
	^ false</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Datum class</class-id> <category>testing</category>

<body package="einfacheBsp" selector="istSchaltjahr:">istSchaltjahr: jahr
	" Liefert 'true', wenn jahr ein Schaltjahr ist, sonst 'false'. "

	( jahr \\ 4 ~= 0 or: [ jahr \\ 100 = 0 and: [ jahr \\ 400 ~= 0 ] ] )
		ifTrue: [
			^ false
		].

	^ true</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="newJahr:monatsnummer:tag:">newJahr: jahr monatsnummer: monat tag: tag

	^ (super new) jj: jahr mm: monat tt: tag</body>

<body package="einfacheBsp" selector="new">new

	| heute |

	heute := Date today.
	^ Datum
		newJahr: heute year
		monatsnummer: heute monthIndex
		tag: heute dayOfMonth</body>

<body package="einfacheBsp" selector="heute">heute

	^ Datum new</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="jj">jj

	^ jj</body>

<body package="einfacheBsp" selector="monatsname">monatsname

	^ Monatsnamen at: self mm</body>

<body package="einfacheBsp" selector="mm">mm

	^ mm</body>

<body package="einfacheBsp" selector="tt">tt

	^ tt</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>testing</category>

<body package="einfacheBsp" selector="istSchaltjahr">istSchaltjahr

	^ self class istSchaltjahr: self jj</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="lfdTagDesJahres">lfdTagDesJahres

	| lfd |
	lfd := (LfdTagMonatsanfang at: self mm) + self tt - 1.
	( self mm &gt; 2 and: [self istSchaltjahr] )
		ifTrue: [
			lfd := lfd + 1
		].
	^ lfd</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>printing</category>

<body package="einfacheBsp" selector="printOn:">printOn: aStream
	"Datum in Form von TT. MM. JJJJ."

	aStream
		nextPutAll: self tt printString , '. ' , self mm printString , '. ' , self jj printString</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>private</category>

<body package="einfacheBsp" selector="jj:mm:tt:">jj: jahr mm: monat tt: tag
	"Datum wird geprüft.
	 Die Fehlerbehandlung ist der Einfachheit halber sehr primitiv, denn ein falsches Datum bewirkt einen Programmabsturz!"

	| tageProMonat |

	(jahr = 0)
		ifTrue: [
			self error: 'ungültiges Jahr'
		].
	( monat &lt; 1 or: [monat &gt; 12] )
		ifTrue: [
			self error: 'ungültiger Monat'
		].
	tageProMonat := TageProMonat at: monat.
	( monat = 2 and: [Datum istSchaltjahr: jahr] )
		ifTrue: [
			tageProMonat := tageProMonat + 1
		].
	( tag &lt; 1 or: [tag &gt; tageProMonat] )
		ifTrue: [
			self error: 'ungültiger Tag'
		].
	jj := jahr.
	mm := monat.
	tt := tag</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Auto class</class-id> <category>class initialization</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Klassenkonstruktor.
	 Initialisiert Klassenvariable und/oder Klasseninstanzvariable."

	MwstSatz := 20</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto class</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="mwstSatz">mwstSatz

	^ MwstSatz</body>

<body package="einfacheBsp" selector="mwstSatz:">mwstSatz: mwstSatz

	MwstSatz := mwstSatz</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="new">new
	"Standardkonstruktor."

	^ super new initialize</body>
</methods>


<methods>
<class-id>BeringerEinfacheBsp.Auto</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="farbe">farbe

	^ farbe</body>

<body package="einfacheBsp" selector="geschwindigkeit:">geschwindigkeit: neueGeschwindigkeit
	"Ändert die aktuelle Geschwindigkeit.
	 Es erfolgt aber keine Prüfung auf Plausibilität!"

	geschwindigkeit := neueGeschwindigkeit</body>

<body package="einfacheBsp" selector="besitzer:">besitzer: neuerBesitzer

	besitzer := neuerBesitzer</body>

<body package="einfacheBsp" selector="geschwindigkeit">geschwindigkeit

	^ geschwindigkeit</body>

<body package="einfacheBsp" selector="besitzer">besitzer

	^ besitzer</body>

<body package="einfacheBsp" selector="gang:">gang: neuerGang
	"Legt anderen Gang ein - es erfolgt eine Prüfung auf Gültigkeit!
	 Der eingelegte Gang kann nicht kleiner sein als 1 und nicht höher als die Anzahl der Gänge.
	 Bei einem Fehler wird der Gang nicht geändert."

	( (neuerGang &gt;= 1) and: [neuerGang &lt;= anzahlGaenge] )
		ifTrue: [
			gang := neuerGang
		]</body>

<body package="einfacheBsp" selector="anzahlGaenge:">anzahlGaenge: neueAnzahlGaenge
	"Ändert die Maximalanzahl der Gänge des Autos - dies entspricht einem Umbau des Autos.
	 Der eingelegte Gang wird auf 1 zurückgesetzt."

	(neueAnzahlGaenge &gt;= 1)
		ifTrue: [
			anzahlGaenge := neueAnzahlGaenge
		].
	self gang: 1</body>

<body package="einfacheBsp" selector="gang">gang

	^ gang</body>

<body package="einfacheBsp" selector="anzahlGaenge">anzahlGaenge

	^ anzahlGaenge</body>

<body package="einfacheBsp" selector="farbe:">farbe: neueFarbe

	farbe := neueFarbe</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto</class-id> <category>printing</category>

<body package="einfacheBsp" selector="printOn:">printOn: aStream
	"Vererbte Methode 'printOn:' überschreiben.
	Dient zur textuellen Darstellung einer Auto-Instanz.
	Ermöglicht der Methode 'printString' eine sinnvolle Ausgabe.

	Achtung: Besitzer sollte bereits initialisiert sein!

	String-Darstellung einer Auto-Instanz:
	            Auto-Daten: [ Mehrwertsteuersatz = ...%
	                 Besitzer = ..., Farbe = ..., Anzahl Gaenge = ...
	                 eingelegter Gang = ... / aktuelle Geschwindigkeit = ... ]"

	aStream
		nextPutAll: self class name , '-Daten: [ Mehrwertsteuersatz = ' , self class mwstSatz printString , '%' ; cr;
		nextPutAll: '     Besitzer = ' , self besitzer heisst printString
					 , ', Farbe = ' , self farbe printString
					 , ', Anzahl Gänge = ' , self anzahlGaenge printString	; cr;
		nextPutAll: '     eingelegter Gang = ' , self gang printString
					 , ' / aktuelle Geschwindigkeit = ' , self geschwindigkeit printString
					 , ' ]'</body>

<body package="einfacheBsp" selector="zeigeInhalt">zeigeInhalt
	"Schreibt alle Attribute in die Standardausgabe.
	 Anstelle dieser Methode sollte besser die Methode 'printOn:' überschrieben werden.

	 Achtung: Besitzer sollte bereits initialisiert sein!"

	Transcript
		cr; show: self class name , '-Daten: [ Mehrwertsteuersatz = ' , self class mwstSatz printString , '%';
		cr; show: '     Besitzer = ' , self besitzer heisst printString
					, ', Farbe = ' , self farbe printString
					, ', Anzahl Gänge = ' , self anzahlGaenge printString;
		cr; show: '     eingelegter Gang = ' , self gang printString
					, ' / aktuelle Geschwindigkeit = ' , self geschwindigkeit printString
					, ' ]'</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="beschleunigen">beschleunigen

	geschwindigkeit := geschwindigkeit * 1.1</body>

<body package="einfacheBsp" selector="runterschalten">runterschalten

	(gang &gt; 1)
		ifTrue: [
			gang := gang - 1
		]</body>

<body package="einfacheBsp" selector="bremsen">bremsen

	geschwindigkeit := geschwindigkeit * 0.9</body>

<body package="einfacheBsp" selector="raufschalten">raufschalten

	(gang &lt; anzahlGaenge)
		ifTrue: [
			gang := gang + 1
		]</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto</class-id> <category>initialize-release</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Initialisiert ein neu erzeugtes Objekt.
	 Alle Attribute (ausgenommen Besitzer) werden mit fixen Werten initialisiert.
	 Es wird eine Anfangsgeschwindigkeit von 10 km/h angenommen."

	super initialize.
	self besitzer: nil.
	self farbe: 'rot'.
	self anzahlGaenge: 5.
	self geschwindigkeit: 10.0.
	self gang: 1.
	^ self</body>
</methods>



<initialize>
<variable-id>BeringerEinfacheBsp.Datum.LfdTagMonatsanfang</variable-id>
</initialize>

<initialize>
<variable-id>BeringerEinfacheBsp.Datum.Monatsnamen</variable-id>
</initialize>

<initialize>
<variable-id>BeringerEinfacheBsp.Datum.TageProMonat</variable-id>
</initialize>

<initialize>
<variable-id>BeringerEinfacheBsp.Person.MAENNLICH</variable-id>
</initialize>

<initialize>
<variable-id>BeringerEinfacheBsp.Person.WEIBLICH</variable-id>
</initialize>

<initialize>
<class-id>BeringerEinfacheBsp.Auto</class-id>
</initialize>

<initialize>
<class-id>BeringerEinfacheBsp.Zaehler3</class-id>
</initialize>

<initialize>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id>
</initialize>

</st-source>
