<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® Personal Use Edition, 7.10.1 of 06. Februar 2014 on 31. Mai 2014 at 11:31:26</time-stamp>


<class>
<name>Auto</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>farbe anzahlGaenge geschwindigkeit gang besitzer </inst-vars>
<class-inst-vars>MwstSatz </class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>BeringerEinfacheBsp.Auto class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="new">new
	"Standardkonstruktor."

	^ super new initialize</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto class</class-id> <category>class initialization</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Klassenkonstruktor.
	 Initialisiert Klassenvariable und/oder Klasseninstanzvariable."

	MwstSatz := 20</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto class</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="mwstSatz">mwstSatz

	^ MwstSatz</body>

<body package="einfacheBsp" selector="mwstSatz:">mwstSatz: mwstSatz

	MwstSatz := mwstSatz</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>BeringerEinfacheBsp.Auto</class-id>
<body>Eine sehr einfache Auto-Klasse, jede Instanz dieser Klasse repräsentiert ein Auto.
Jede Instanz wird mit einer Anfangsgeschwindigkeit von 10 km/h initialisiert.
Rauf- und runterschalten bewirkt keine Geschwindigkeitsänderung.
Bremsen und beschleunigen bewirkt immer eine Geschwindigkeitsänderung von 10%, jedoch keinen Gangwechsel.
Es wurde zusätzlich noch (neben der Methode 'zeigeInhalt') die Methode 'printOn:' überschrieben.

Class Instance Variables
	MwstSatz		&lt;Float&gt;	Mehrwertsteuersatz

Instance Variables
	besitzer				&lt;Person&gt;	Besitzer des Autos
	farbe					&lt;String&gt;		Farbe des Autos
	anzahlGaenge		&lt;Integer&gt;		Anzahl der Gänge
	gang					&lt;Integer&gt;		eingelegter Gang
	geschwindigkeit		&lt;Float&gt;		aktuelle Geschwindigkeit

**************************************
"AutoTesten"

| auto |

auto := Auto new.

auto besitzer: (BeringerEinfacheBsp.Person newGeburtsjahr: 1980  geschlecht: $M).
auto farbe: 'blau'.
auto raufschalten.
auto zeigeInhalt.

Auto mwstSatz: 20.
auto besitzer aendernVorname: 'Hugo'.
auto raufschalten.
auto raufschalten.
auto zeigeInhalt.

auto runterschalten.
auto beschleunigen.
auto zeigeInhalt.

auto bremsen.
auto zeigeInhalt.
</body>
</comment>

<methods>
<class-id>BeringerEinfacheBsp.Auto</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="anzahlGaenge">anzahlGaenge

	^ anzahlGaenge</body>

<body package="einfacheBsp" selector="anzahlGaenge:">anzahlGaenge: neueAnzahlGaenge
	"Ändert die Maximalanzahl der Gänge des Autos - dies entspricht einem Umbau des Autos.
	 Der eingelegte Gang wird auf 1 zurückgesetzt."

	(neueAnzahlGaenge &gt;= 1)
		ifTrue: [
			anzahlGaenge := neueAnzahlGaenge
		].
	self gang: 1</body>

<body package="einfacheBsp" selector="besitzer">besitzer

	^ besitzer</body>

<body package="einfacheBsp" selector="besitzer:">besitzer: neuerBesitzer

	besitzer := neuerBesitzer</body>

<body package="einfacheBsp" selector="farbe">farbe

	^ farbe</body>

<body package="einfacheBsp" selector="farbe:">farbe: neueFarbe

	farbe := neueFarbe</body>

<body package="einfacheBsp" selector="gang">gang

	^ gang</body>

<body package="einfacheBsp" selector="gang:">gang: neuerGang
	"Legt anderen Gang ein - es erfolgt eine Prüfung auf Gültigkeit!
	 Der eingelegte Gang kann nicht kleiner sein als 1 und nicht höher als die Anzahl der Gänge.
	 Bei einem Fehler wird der Gang nicht geändert."

	( (neuerGang &gt;= 1) and: [neuerGang &lt;= anzahlGaenge] )
		ifTrue: [
			gang := neuerGang
		]</body>

<body package="einfacheBsp" selector="geschwindigkeit">geschwindigkeit

	^ geschwindigkeit</body>

<body package="einfacheBsp" selector="geschwindigkeit:">geschwindigkeit: neueGeschwindigkeit
	"Ändert die aktuelle Geschwindigkeit.
	 Es erfolgt aber keine Prüfung auf Plausibilität!"

	geschwindigkeit := neueGeschwindigkeit</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto</class-id> <category>initialize-release</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Initialisiert ein neu erzeugtes Objekt.
	 Alle Attribute (ausgenommen Besitzer) werden mit fixen Werten initialisiert.
	 Es wird eine Anfangsgeschwindigkeit von 10 km/h angenommen."

	super initialize.
	self besitzer: nil.
	self farbe: 'rot'.
	self anzahlGaenge: 5.
	self geschwindigkeit: 10.0.
	self gang: 1.
	^ self</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto</class-id> <category>printing</category>

<body package="einfacheBsp" selector="printOn:">printOn: aStream
	"Vererbte Methode 'printOn:' überschreiben.
	Dient zur textuellen Darstellung einer Auto-Instanz.
	Ermöglicht der Methode 'printString' eine sinnvolle Ausgabe.

	Achtung: Besitzer sollte bereits initialisiert sein!

	String-Darstellung einer Auto-Instanz:
	            Auto-Daten: [ Mehrwertsteuersatz = ...%
	                 Besitzer = ..., Farbe = ..., Anzahl Gaenge = ...
	                 eingelegter Gang = ... / aktuelle Geschwindigkeit = ... ]"

	aStream
		nextPutAll: self class name , '-Daten: [ Mehrwertsteuersatz = ' , self class mwstSatz printString , '%' ; cr;
		nextPutAll: '     Besitzer = ' , self besitzer heisst printString
					 , ', Farbe = ' , self farbe printString
					 , ', Anzahl Gänge = ' , self anzahlGaenge printString	; cr;
		nextPutAll: '     eingelegter Gang = ' , self gang printString
					 , ' / aktuelle Geschwindigkeit = ' , self geschwindigkeit printString
					 , ' ]'</body>

<body package="einfacheBsp" selector="zeigeInhalt">zeigeInhalt
	"Schreibt alle Attribute in die Standardausgabe.
	 Anstelle dieser Methode sollte besser die Methode 'printOn:' überschrieben werden.

	 Achtung: Besitzer sollte bereits initialisiert sein!"

	Transcript
		cr; show: self class name , '-Daten: [ Mehrwertsteuersatz = ' , self class mwstSatz printString , '%';
		cr; show: '     Besitzer = ' , self besitzer heisst printString
					, ', Farbe = ' , self farbe printString
					, ', Anzahl Gänge = ' , self anzahlGaenge printString;
		cr; show: '     eingelegter Gang = ' , self gang printString
					, ' / aktuelle Geschwindigkeit = ' , self geschwindigkeit printString
					, ' ]'</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Auto</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="beschleunigen">beschleunigen

	geschwindigkeit := geschwindigkeit * 1.1</body>

<body package="einfacheBsp" selector="bremsen">bremsen

	geschwindigkeit := geschwindigkeit * 0.9</body>

<body package="einfacheBsp" selector="raufschalten">raufschalten

	(gang &lt; anzahlGaenge)
		ifTrue: [
			gang := gang + 1
		]</body>

<body package="einfacheBsp" selector="runterschalten">runterschalten

	(gang &gt; 1)
		ifTrue: [
			gang := gang - 1
		]</body>
</methods>

<initialize>
<class-id>BeringerEinfacheBsp.Auto</class-id>
</initialize>

</st-source>
