<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® Personal Use Edition, 7.10.1 of 06. Februar 2014 on 31. Mai 2014 at 12:05:27</time-stamp>


<class>
<name>Datum</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>jj mm tt </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<shared-variable>
<name>LfdTagMonatsanfang</name>
<environment>BeringerEinfacheBsp.Datum</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>#(1 32 60 91 121 152 182 213 244 274 305 335)</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>

<shared-variable>
<name>TageProMonat</name>
<environment>BeringerEinfacheBsp.Datum</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>#(31 28 31 30 31 30 31 31 30 31 30 31)</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>

<shared-variable>
<name>Monatsnamen</name>
<environment>BeringerEinfacheBsp.Datum</environment>
<private>false</private>
<constant>false</constant>
<category>Klassenvariable</category>
<initializer>#('Jänner' 'Februar' 'März' 'April' 'Mai' 'Juni' 'Juli' 'August' 'September' 'Oktober' 'November' 'Dezember' )</initializer>
<attributes>
<package>einfacheBsp</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>BeringerEinfacheBsp.Datum class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="heute">heute

	^ Datum new</body>

<body package="einfacheBsp" selector="new">new

	| heute |

	heute := Date today.
	^ Datum
		newJahr: heute year
		monatsnummer: heute monthIndex
		tag: heute dayOfMonth</body>

<body package="einfacheBsp" selector="newJahr:monatsnummer:tag:">newJahr: jahr monatsnummer: monat tag: tag

	^ (super new) jj: jahr mm: monat tt: tag</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum class</class-id> <category>testing</category>

<body package="einfacheBsp" selector="istSchaltjahr:">istSchaltjahr: jahr
	" Liefert 'true', wenn jahr ein Schaltjahr ist, sonst 'false'. "

	( jahr \\ 4 ~= 0 or: [ jahr \\ 100 = 0 and: [ jahr \\ 400 ~= 0 ] ] )
		ifTrue: [
			^ false
		].

	^ true</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>BeringerEinfacheBsp.Datum</class-id>
<body>Eine einfache Datumsklasse.

Class Variables
	Monatsnamen			&lt;String-Array&gt;		Monatsnamen
	TageProMonat			&lt;Integer-Array&gt;		Anzahl der Tage jedes Monats
	LfdTagMonatsanfang		&lt;String-Array&gt;		Laufende Tageszahl am 1. jedes Monats


Instance Variables
	jj		&lt;Integer&gt;		Jahr
	mm		&lt;Integer&gt;		Monat
	tt		&lt;Integer&gt;		Tag

**************************************
"DatumTesten"

| dat1 dat2 dat3 |

dat1 := Datum newJahr: 1988 monatsnummer: 2 tag:17.
dat1 istSchaltjahr.			"&lt;Print it&gt; liefert true"
dat1 lfdTagDesJahres.		"&lt;Print it&gt; liefert 48"
dat1.						"&lt;Print it&gt; liefert 17. 2. 1988"
dat2 := Datum heute.
dat2 istSchaltjahr.
dat2 lfdTagDesJahres.
dat3 := Datum new.
dat3 istSchaltjahr.
dat3 lfdTagDesJahres.

"--------------------------------------"

| jj today dat |

jj := 2000.
today := Datum heute.
dat := Datum newJahr: 1950 monatsnummer: 4 tag:25.

Datum istSchaltjahr: jj.			"&lt;Print it&gt; liefert true"

Transcript show: 'today = ';
               show: today tt printString; show: '.';
               show: today mm printString; show: '.';
               show: today jj printString; cr.
today istSchaltjahr.
today lfdTagDesJahres.

Transcript clear.
Transcript show: 'dat = ';
               show: dat tt printString; show: '.';
               show: dat mm printString; show: '.';
               show: dat jj printString; cr.

Transcript show: 'heutiger Tag = ';
               show: Datum heute tt printString; cr;
               show: 'heutiger Monat = ';
               show: Datum heute monatsname printString; cr;
               show: 'aktuelles Jahr = ';
               show: Datum heute jj printString; cr.
</body>
</comment>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="jj">jj

	^ jj</body>

<body package="einfacheBsp" selector="mm">mm

	^ mm</body>

<body package="einfacheBsp" selector="monatsname">monatsname

	^ Monatsnamen at: self mm</body>

<body package="einfacheBsp" selector="tt">tt

	^ tt</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="lfdTagDesJahres">lfdTagDesJahres

	| lfd |
	lfd := (LfdTagMonatsanfang at: self mm) + self tt - 1.
	( self mm &gt; 2 and: [self istSchaltjahr] )
		ifTrue: [
			lfd := lfd + 1
		].
	^ lfd</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>printing</category>

<body package="einfacheBsp" selector="printOn:">printOn: aStream
	"Datum in Form von TT. MM. JJJJ."

	aStream
		nextPutAll: self tt printString , '. ' , self mm printString , '. ' , self jj printString</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>private</category>

<body package="einfacheBsp" selector="jj:mm:tt:">jj: jahr mm: monat tt: tag
	"Datum wird geprüft.
	 Die Fehlerbehandlung ist der Einfachheit halber sehr primitiv, denn ein falsches Datum bewirkt einen Programmabsturz!"

	| tageProMonat |

	(jahr = 0)
		ifTrue: [
			self error: 'ungültiges Jahr'
		].
	( monat &lt; 1 or: [monat &gt; 12] )
		ifTrue: [
			self error: 'ungültiger Monat'
		].
	tageProMonat := TageProMonat at: monat.
	( monat = 2 and: [Datum istSchaltjahr: jahr] )
		ifTrue: [
			tageProMonat := tageProMonat + 1
		].
	( tag &lt; 1 or: [tag &gt; tageProMonat] )
		ifTrue: [
			self error: 'ungültiger Tag'
		].
	jj := jahr.
	mm := monat.
	tt := tag</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Datum</class-id> <category>testing</category>

<body package="einfacheBsp" selector="istSchaltjahr">istSchaltjahr

	^ self class istSchaltjahr: self jj</body>
</methods>

<initialize>
<variable-id>BeringerEinfacheBsp.Datum.LfdTagMonatsanfang</variable-id>
</initialize>

<initialize>
<variable-id>BeringerEinfacheBsp.Datum.TageProMonat</variable-id>
</initialize>

<initialize>
<variable-id>BeringerEinfacheBsp.Datum.Monatsnamen</variable-id>
</initialize>

</st-source>
