<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® Personal Use Edition, 7.10.1 of 06. Februar 2014 on 31. Mai 2014 at 12:09:56</time-stamp>


<class>
<name>Zaehler2</name>
<environment>BeringerEinfacheBsp</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>wert </inst-vars>
<class-inst-vars>Endwert </class-inst-vars>
<imports></imports>
<category>Einfache Beispiele</category>
<attributes>
<package>einfacheBsp</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>BeringerEinfacheBsp.Zaehler2 class</class-id> <category>instance creation</category>

<body package="einfacheBsp" selector="new">new
	"Standardkonstruktor.
	 Zähler wird zurückgesetzt."

	^ super new reset</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2 class</class-id> <category>class initialization</category>

<body package="einfacheBsp" selector="initialize">initialize
	"Klassenkonstruktor.
	 Für einen zweistelligen Zähler wird der Endwert auf 99 gesetzt."

	Endwert := 99</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2 class</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="endwert">endwert

	^ Endwert</body>

<body package="einfacheBsp" selector="endwert:">endwert: endwert
	"Definiert einen neuen Endwert für den Zähler - es erfolgt jedoch keine Prüfung auf Plausibilität!"

	Endwert := endwert</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id>
<body>Instanzen dieser Klasse repräsentieren einen einfachen zweistelligen Zähler, der (um 1) erhöht und (auf 0) zurückgesetzt werden kann.
Der Zähler beginnt nach 99 (= Standardwert für Endwert) wieder bei 0, d.h. bei 100 erfolgt ein Überlauf.

Class Instance Variables
	Endwert	&lt;Integer&gt;		maximaler Wert des Zählers

Instance Variables
	wert	&lt;Integer&gt;		aktueller Stand des Zählers

**************************************
"Zaehler2Testen"

| z |

Transcript clear.

z := Zaehler2 new.
z erhoehen.
1 to: 3 do: [ :k |
	1 to: 80 do: [ :i |
		z erhoehen 
	].
	Transcript cr;
			show: z wert printString
]
</body>
</comment>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id> <category>accessing</category>

<body package="einfacheBsp" selector="wert">wert

	^ wert</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id> <category>berechnungen</category>

<body package="einfacheBsp" selector="erhoehen">erhoehen
	"Erhöht den Zähler um 1 - bei Überlauf wird Zähler zurückgesetzt."

	self wert: (self wert + 1).
	^ self wert</body>

<body package="einfacheBsp" selector="reset">reset
	"Setzt den Zähler zurück auf 0.
	 Kein expliziter Rückgabewert - somit wird das Zaehler-Objekt selbst zurückgegeben (entspricht   ^self)."

	self wert: 0</body>
</methods>

<methods>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id> <category>private</category>

<body package="einfacheBsp" selector="wert:">wert: neuerWert
	"Ändert den Wert des Zählers.
	 Der neue Wert muss zwischen 0 und Endwert liegen."

	wert := neuerWert.
	( (self wert &gt; self class endwert) or: [self wert &lt; 0] ) 
		ifTrue: [
			self reset
		]</body>
</methods>

<initialize>
<class-id>BeringerEinfacheBsp.Zaehler2</class-id>
</initialize>

</st-source>
