<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® Personal Use Edition, 7.10.1 of 06. Februar 2014 on 31. Mai 2014 at 11:32:41</time-stamp>


<class>
<name>Mitarbeiter</name>
<environment>BeringerOrganisation</environment>
<super>BeringerOrganisation.Person</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>persNr stellung grundgehalt organisation </inst-vars>
<class-inst-vars>MaxGehalt </class-inst-vars>
<imports></imports>
<category>Beispiel Organisation</category>
<attributes>
<package>organisation</package>
</attributes>
</class>

<shared-variable>
<name>LetztePersNr</name>
<environment>BeringerOrganisation.Mitarbeiter</environment>
<private>true</private>
<constant>false</constant>
<category>Klassenvariable</category>
<initializer>0</initializer>
<attributes>
<package>organisation</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>BeringerOrganisation.Mitarbeiter class</class-id> <category>class initialization</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert Klassenvariable und/oder Klasseninstanzvariable."

	Mitarbeiter letztePersNr: 0.
	Mitarbeiter maxGehalt: 4500</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Mitarbeiter class</class-id> <category>accessing</category>

<body package="organisation" selector="letztePersNr">letztePersNr

	^ LetztePersNr</body>

<body package="organisation" selector="maxGehalt">maxGehalt

	^ MaxGehalt</body>

<body package="organisation" selector="maxGehalt:">maxGehalt: eineZahl

	MaxGehalt := eineZahl</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Mitarbeiter class</class-id> <category>private</category>

<body package="organisation" selector="letztePersNr:">letztePersNr: eineZahl

	LetztePersNr := eineZahl</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>BeringerOrganisation.Mitarbeiter</class-id>
<body>Jede Instanz dieser Klasse repräsentiert eine Mitarbeiterin bzw. einen Mitarbeiter.

Class Variables
	LetztePersNr		&lt;Integer&gt;		zuletzt vergebene Personalnummer

Class Instance Variables
	MaxGehalt			&lt;Float&gt;			monatliches Maximalgehalt ohne Zuschläge


Instance Variables
	persNr			&lt;Integer&gt;			unternehmensweit eindeutige Personalnummer
	stellung			&lt;String&gt;			Funktion bzw. Position, die eine Mitarbeiterin bzw. ein Mitarbeiter im Unternehmen hat
	grundgehalt		&lt;Float&gt;				monatliches Gehalt ohne Zuschläge
	organisation		&lt;Organisation&gt;		Abteilung oder Projekt, in der bzw. in dem eine Mitarbeiterin bzw. ein Mitarbeiter arbeitet
</body>
</comment>

<methods>
<class-id>BeringerOrganisation.Mitarbeiter</class-id> <category>accessing</category>

<body package="organisation" selector="grundgehalt">grundgehalt

	^ grundgehalt</body>

<body package="organisation" selector="grundgehalt:">grundgehalt: eineZahl
	"Ändert das Grundgehalt des Mitarbeiters (soferne es nicht größer als das maximale Gehalt ist)."

	(eineZahl &lt;= self class maxGehalt)
		ifTrue: [
			grundgehalt := eineZahl.
			^ true
		].

	self error: 'Grundgehalt von ' , self class name , ' kann maximal sein: ' , self class maxGehalt printString.
	^ false</body>

<body package="organisation" selector="organisation">organisation

	^ organisation</body>

<body package="organisation" selector="organisation:">organisation: eineOrganisation
	"Ändert die Organisation des Mitarbeiters und fügt ihn in die neue Organisation ein, falls er dieser noch nicht angehört."

	(eineOrganisation isKindOf: Organisation)
		ifTrue: [
			(self organisation notNil)
				ifTrue: [
					self organisation removeMitarbeiter: self
				].
			organisation := eineOrganisation.
			organisation addMitarbeiter: self
		]
		ifFalse: [
			(eineOrganisation isNil)
				ifTrue: [
					(self organisation notNil)
						ifTrue: [
							self organisation removeMitarbeiter: self
						].
					organisation := eineOrganisation
				]
				ifFalse: [
					self error: eineOrganisation class name , ' ist keine gültige Organisation'
				]
		]</body>

<body package="organisation" selector="persNr">persNr

	^ persNr</body>

<body package="organisation" selector="stellung">stellung

	^ stellung</body>

<body package="organisation" selector="stellung:">stellung: neueStellung

	stellung := neueStellung</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Mitarbeiter</class-id> <category>initialize-release</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert eine neu erstellte Instanz.
	 Die Bezeichnung der Stellung ist der Einfachheit halber nicht geschlechtsneutral."

	super initialize.
	self
		persNrNeu;
		stellung: 'Mitarbeiter';
		grundgehalt: 1200;
		organisation: nil.
	^ self</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Mitarbeiter</class-id> <category>private</category>

<body package="organisation" selector="persNrNeu">persNrNeu
	"Ordnet jedem Mitarbeiter eine unternehmensweit eindeutige (fortlaufende) Personalnummer zu."

	(persNr isNil)
		ifTrue: [
			self class letztePersNr: (self class letztePersNr + 1).
			persNr := self class letztePersNr.
			^ true
		].

	self error: ' Mitarbeiter hat bereits eine Personalnummer!'.
	^ false</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Mitarbeiter</class-id> <category>berechnungen</category>

<body package="organisation" selector="anrede">anrede

	^ super anrede , ' ' , self stellung , ' ' , self name</body>

<body package="organisation" selector="verdient">verdient

	^ self grundgehalt</body>
</methods>

<initialize>
<variable-id>BeringerOrganisation.Mitarbeiter.LetztePersNr</variable-id>
</initialize>

<initialize>
<class-id>BeringerOrganisation.Mitarbeiter</class-id>
</initialize>

</st-source>
