<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® Personal Use Edition, 7.10.1 of 06. Februar 2014 on 31. Mai 2014 at 11:32:46</time-stamp>


<class>
<name>Organisation</name>
<environment>BeringerOrganisation</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>name leiter mitarbeiterliste sachkosten </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Beispiel Organisation</category>
<attributes>
<package>organisation</package>
</attributes>
</class>

<comment>
<class-id>BeringerOrganisation.Organisation</class-id>
<body>Abstrakte Klasse für organisatorische Einheiten in einem Unternehmen.
Organisatorische Einheiten können Abteilungen, Projekte usw. sein.

Instance Variables
	name			&lt;String&gt;				Name der Organisation
	leiter			&lt;Manager&gt;				Leiter/Leiterin der Organisation
	mitarbeiterliste	&lt;Set of Mitarbeiter&gt;		Mitarbeiterliste
	sachkosten		&lt;Float&gt;					Sachkosten

****************************************************************************
"Anwendungsprogramm für Beispiel Personen-Mitarbeiter-Organisation"

| mita11 mita12 mita2 mitp1 mitp21 mitp22 
  mana1  mana2  manp1 manp2
  abt1   abt2
  proj1  proj2 |

Mitarbeiter initialize.

abt1 := Abteilung new.
abt1 name: 'Abt1';
     einnahmen: 200000;
     sachkosten: 7000.

abt2 := Abteilung new.
abt2 name: 'Abt2';
     einnahmen: 350000.

proj1 := Projekt new.
proj1 name: 'Projekt1'.

proj2 := Projekt new.
proj2 name: 'Projekt2';
      sachkosten: 5500;
      planZeit: 2;
      planJahresgewinn: 600000;
      planLebensdauer: 6.

"mita11 := Mitarbeiter new.		***error*** geht nicht"
mita11 := Mitarbeiter newGeburtsdatum: (Date readFromString:'07/17/1962') geschlecht: $M.
mita11 name: 'Huber Hans'.
mita11 grundgehalt: 2100;
       organisation: abt1.

mita12 := Mitarbeiter newGeburtsdatum: (Date readFromString:'01/13/1977') geschlecht: $W.
mita12 name: 'Irene Gross'.
mita12 grundgehalt: 2500;
       organisation: abt1.

mita2 := Mitarbeiter newName: 'Karli' geburtsdatum: (Date today) geschlecht: $M.
mita2 organisation: abt2.

mitp1 := Mitarbeiter newName: 'Doris' geburtsdatum: (Date today) geschlecht: $W.
mitp1 organisation: proj1.

mitp21 := Mitarbeiter newName: 'Hansi' geburtsdatum: (Date today) geschlecht: $M.
mitp21 organisation: proj2.

mitp22 := Mitarbeiter newName: 'Helga' geburtsdatum: (Date today) geschlecht: $W.
mitp22 organisation: proj2.

mana1 := Manager newName: 'Klammer Franz' geburtsdatum: (Date today) geschlecht: $M.
mana1 grundgehalt: 5500;
      organisation: abt1;
      geleiteteOrganisation: abt1.

mana2 := Manager newName: 'Muster Tom' geburtsdatum: (Date today) geschlecht: $M.
mana2 organisation: abt2;
      geleiteteOrganisation: abt2.

manp1 := Manager newName: 'Toni' geburtsdatum: (Date today) geschlecht: $M.
manp1 organisation: proj1;
      geleiteteOrganisation: proj1.

manp2 := Manager newName: 'Annemarie' geburtsdatum: (Date today) geschlecht: $W.
manp2 grundgehalt: 4700;
      organisation: proj2;
      geleiteteOrganisation: proj2.

Transcript clear; show: 'Personalnummern: ' , 
                                     mita11 persNr printString , ' ' , mita12 persNr printString , ' ' ,
                                     mita2 persNr printString  , ' ' , mitp1 persNr printString  , ' ' ,
                                     mitp21 persNr printString , ' ' , mitp22 persNr printString , ' ' ,
                                     mana1 persNr printString  , ' ' , mana2 persNr printString  , ' ' ,
                                     manp1 persNr printString  , ' ' , manp2 persNr printString.

Transcript cr; show: mita12 anrede printString.
Transcript cr; show: mana1 anrede printString.

Transcript cr; show: mita11 alterBerechnen printString.
Transcript cr; show: mita12 alterBerechnen printString.

Transcript cr; show: mita11 verdient printString.
Transcript cr; show: mana1 verdient printString.
Transcript cr; show: manp2 verdient printString.

abt1 druckeAlleMitarbeiter.     Transcript cr.
abt2 druckeAlleMitarbeiter.     Transcript cr.
proj1 druckeAlleMitarbeiter.    Transcript cr.
proj2 druckeAlleMitarbeiter.    Transcript cr.

abt1 druckeKostenUebersicht.    Transcript cr.
proj2 druckeKostenUebersicht.   Transcript cr.
</body>
</comment>

<methods>
<class-id>BeringerOrganisation.Organisation</class-id> <category>accessing</category>

<body package="organisation" selector="addMitarbeiter:">addMitarbeiter: einMitarbeiter
	"Fügt einen neuen Mitarbeiter hinzu; wird gegebenenfalls aus seiner vorhergehenden Organisation entfernt."

	| bisherigeOrg |

	bisherigeOrg := einMitarbeiter organisation.
	(bisherigeOrg ~= self)
		ifTrue: [
			(bisherigeOrg notNil)
				ifTrue: [
					bisherigeOrg removeMitarbeiter: einMitarbeiter
				].
			einMitarbeiter organisation: self
		].
	mitarbeiterliste add: einMitarbeiter</body>

<body package="organisation" selector="leiter">leiter

	^ leiter</body>

<body package="organisation" selector="leiter:">leiter: einManager

	leiter := einManager</body>

<body package="organisation" selector="mitarbeiterliste">mitarbeiterliste

	^ mitarbeiterliste</body>

<body package="organisation" selector="name">name

	^ name</body>

<body package="organisation" selector="name:">name: neuerName

	name := neuerName</body>

<body package="organisation" selector="removeMitarbeiter:">removeMitarbeiter: einMitarbeiter

	mitarbeiterliste remove: einMitarbeiter
		ifAbsent: [
			Transcript  cr;  show: 'Mitarbeiter wurde bereits entfernt'
		]</body>

<body package="organisation" selector="sachkosten">sachkosten

	^ sachkosten</body>

<body package="organisation" selector="sachkosten:">sachkosten: eineZahl

	sachkosten := eineZahl</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Organisation</class-id> <category>printing</category>

<body package="organisation" selector="druckeAlleMitarbeiter">druckeAlleMitarbeiter
	"Erstellt eine Übersichtsliste aller Mitarbeiter + Leiter der Organisation."

	Transcript  cr;  show: self class name , ': ' , self name.
	(self leiter isNil)
		ifTrue: [
			Transcript  cr;  show: 'noch kein Leiter ernannt.'
		]
		ifFalse: [
			Transcript  cr;  show: 'geleitet von: ' , self leiter name
		].
	Transcript  cr;  show: 'Anzahl Mitarbeiter = ' , mitarbeiterliste size printString.
	mitarbeiterliste do: [ :ma |
			Transcript  cr;  show: ma anrede , ' (Grundgehalt = ' , ma grundgehalt printString , ')'
		]</body>

<body package="organisation" selector="druckeKostenUebersicht">druckeKostenUebersicht
	"Erstellt eine Übersichtsliste der Gesamtkosten der Organisation."

	Transcript  cr;  show: self class name , ': ' , self name , '   Kostenübersicht';
				  cr;  show: '------------------------------------------------------------'.
	Transcript  cr;  show: 'Mitarbeiter';  tab;  	tab;  tab;  	tab;  show: 'Grundgehalt';  tab;  show: 'Verdienst';
				  cr;  show: '------------------------------------------------------------'.
	mitarbeiterliste do: [ :ma |
			Transcript  cr;  show: ma anrede;  tab;  tab;  show: ma grundgehalt printString;  tab;  show: ma verdient printString
		].
	Transcript  cr;  show: '------------------------------------------------------------';
				  cr;  show: 'Personalkosten = ';	tab;  show: self personalkosten printString;
				  cr;  show: 'Prämie =         ';		tab;  show: self praemie printString;
				  cr;  show: 'Sachkosten =     ';	tab;  show: self sachkosten printString;
				  cr;  show: 'Gesamtkosten =   ';	tab;  show: self gesamtkosten printString;
				  cr;  show: 'Gewinn =         ';		tab;  show: self gewinn printString</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Organisation</class-id> <category>berechnungen</category>

<body package="organisation" selector="gesamtkosten">gesamtkosten
	"Berechnet die Gesamtkosten (einschließlich der Prämien der Manager)."

	^ self gesamtkostenOhnePraemie + self praemie</body>

<body package="organisation" selector="gesamtkostenOhnePraemie">gesamtkostenOhnePraemie
	"Berechnet die Gesamtkosten (= Personalkosten + Sachkosten)."

	^ self personalkostenOhnePraemie + self sachkosten</body>

<body package="organisation" selector="gewinn">gewinn
	"Berechnet den Gewinn der Organisation (ohne Prämien der Manager)."

	^ self gewinnOhnePraemie - self praemie</body>

<body package="organisation" selector="gewinnOhnePraemie">gewinnOhnePraemie
	"Abstrakte Methode.
	 Berechnet den Gewinn der Organisation (zur Bestimmung des Gewinnanteils).
	 Dieser ist abhängig von der Art der Organisation (Abteilung oder Projekt)."

	self subclassResponsibility</body>

<body package="organisation" selector="personalkosten">personalkosten
	"Berechnet die Personalkosten aus den Grundgehältern + Prämien der Manager."

	^ self personalkostenOhnePraemie + self praemie</body>

<body package="organisation" selector="personalkostenOhnePraemie">personalkostenOhnePraemie
	"Berechnet die Personalkosten aus den Grundgehältern der Mitarbeiter."

	| summe |

	summe := 0.
	mitarbeiterliste do: [ :ma |
			summe := summe + ma grundgehalt
		].
	^ summe</body>

<body package="organisation" selector="praemie">praemie
	"Berechnet die Prämie des Leiters bzw. der Leiterin der Organisation."

	^ self gewinnOhnePraemie * Manager gewinnanteil</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Organisation</class-id> <category>initialize-release</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert eine neu erstellte Instanz."

	super initialize.
	mitarbeiterliste := Set new.
	self sachkosten: 0.
	^ self</body>
</methods>

</st-source>
