<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® Personal Use Edition, 7.10.1 of 06. Februar 2014 on 31. Mai 2014 at 11:32:50</time-stamp>


<class>
<name>Person</name>
<environment>BeringerOrganisation</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>name geburtsdatum geschlecht adresse </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Beispiel Organisation</category>
<attributes>
<package>organisation</package>
</attributes>
</class>

<shared-variable>
<name>ANREDEMAENNLICH</name>
<environment>BeringerOrganisation.Person</environment>
<private>false</private>
<constant>false</constant>
<category>Klassenvariable</category>
<attributes>
<package>organisation</package>
</attributes>
</shared-variable>

<shared-variable>
<name>MAENNLICH</name>
<environment>BeringerOrganisation.Person</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>$M</initializer>
<attributes>
<package>organisation</package>
</attributes>
</shared-variable>

<shared-variable>
<name>ANREDEWEIBLICH</name>
<environment>BeringerOrganisation.Person</environment>
<private>false</private>
<constant>false</constant>
<category>Klassenvariable</category>
<attributes>
<package>organisation</package>
</attributes>
</shared-variable>

<shared-variable>
<name>WEIBLICH</name>
<environment>BeringerOrganisation.Person</environment>
<private>false</private>
<constant>true</constant>
<category>Klassenvariable</category>
<initializer>$W</initializer>
<attributes>
<package>organisation</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>BeringerOrganisation.Person class</class-id> <category>instance creation</category>

<body package="organisation" selector="new">new
	"Eine Personeninstanz kann nur mit Geburtsdatum und Geschlecht erzeugt werden."

	self error: 'Keine Daten (mindestens Geburtsdatum und Geschlecht sind anzugeben)'</body>

<body package="organisation" selector="newGeburtsdatum:geschlecht:">newGeburtsdatum: einDatum geschlecht: kennzGeschlecht
	"Anlegen einer Personeninstanz mit Geburtsdatum und Geschlecht."

	^ self
		newName: ''
		geburtsdatum: einDatum
		geschlecht: kennzGeschlecht
		adresse: ''</body>

<body package="organisation" selector="newName:geburtsdatum:geschlecht:">newName: einName geburtsdatum: einDatum geschlecht: kennzGeschlecht
	"Anlegen einer Personeninstanz mit Name, Geburtsdatum und Geschlecht."

	^ self
		newName: einName
		geburtsdatum: einDatum
		geschlecht: kennzGeschlecht
		adresse: ''</body>

<body package="organisation" selector="newName:geburtsdatum:geschlecht:adresse:">newName: einName geburtsdatum: einDatum geschlecht: kennzGeschlecht adresse: eineAdresse
	"Anlegen einer Personeninstanz mit allen Attributen."

	^ (super new)
		name: einName;
		geburtsdatum: einDatum;
		geschlecht: kennzGeschlecht;
		adresse: eineAdresse;
		initialize</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Person class</class-id> <category>class initialization</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert Klassenvariable und/oder Klasseninstanzvariable."

	ANREDEMAENNLICH := 'Herr'.
	ANREDEWEIBLICH := 'Frau'</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>BeringerOrganisation.Person</class-id>
<body>Instanzen dieser Klasse repräsentieren natürliche Personen.

Class Variables
	MAENNLICH					&lt;Character&gt;		Kennzeichen für männliches Geschlecht
	WEIBLICH					&lt;Character&gt;		Kennzeichen für weibliches Geschlecht
	ANREDEMAENNLICH		&lt;String&gt;			Anrede für Personen männlichen Geschlechts
	ANREDEWEIBLICH		&lt;String&gt;			Anrede für Personen weiblichen Geschlechts

Instance Variables
	name			&lt;String&gt;			Name
	gebDatum	&lt;Date&gt;			Geburtsdatum
	geschlecht	&lt;Character&gt;		Kennzeichen für Geschlecht (M = männlich, W = weiblich = W)
	adresse		&lt;String&gt;			Adresse


**************************************
"PersonTesten"

"Anlegen einer Person"

	Person new.			"nicht erlaubt!"

"Pflege der Personendaten"

	| p1 p2 |

	p1 := Person newName: 'Dr. Karl Huber'
		     gebDatum: (Date readFromString:'07/13/1962')
		     geschlecht: $M.
	p1.				"&lt;Print it&gt; ... Person: Dr. Karl Huber (July 13, 1962) " 
	p2 := Person newGebDatum: (Date readFromString:'07/13/1977') geschlecht: $M.
	p2 name: 'Hugo'.
	p2.

"Berechne das Alter von Huber"

	p1 alterBerechnen.		"&lt;Print it&gt; ... 50 "
</body>
</comment>

<methods>
<class-id>BeringerOrganisation.Person</class-id> <category>accessing</category>

<body package="organisation" selector="adresse">adresse

	^ adresse</body>

<body package="organisation" selector="adresse:">adresse: neueAdresse

	adresse := neueAdresse</body>

<body package="organisation" selector="geburtsdatum">geburtsdatum

	^ geburtsdatum copy		"Achtung: Nur eine Kopie des Originalobjekts wird zurückgegeben!"</body>

<body package="organisation" selector="geschlecht">geschlecht

	^ geschlecht</body>

<body package="organisation" selector="name">name

	^ name</body>

<body package="organisation" selector="name:">name: neuerName

	name := neuerName</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Person</class-id> <category>initialize-release</category>

<body package="organisation" selector="initialize">initialize
	"Initialisiert eine neu erstellte Instanz.
	 Kann in Subklassen überschrieben werden."

	super initialize.
	^ self</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Person</class-id> <category>private</category>

<body package="organisation" selector="geburtsdatum:">geburtsdatum: einDatum
	"Das neue Geburtsdatum muss vor dem aktuellen Tagesdatum liegen."

	( (einDatum class == Date) and: [einDatum &lt;= Date today] )
		ifTrue: [
			geburtsdatum := einDatum copy.			"Achtung: Nur Kopie des Parameterobjekts verwenden!"
			^ true
		].

	"ungültiges Geburtsdatum"
	geburtsdatum := Date today.					
	^ false</body>

<body package="organisation" selector="geschlecht:">geschlecht: kennzeichen

	geschlecht := kennzeichen.
	( kennzeichen = MAENNLICH or: [kennzeichen = WEIBLICH] )
		ifTrue: [
			^ true
		].

	"ungültiges Kennzeichen für Geschlecht!"
	^ false</body>
</methods>

<methods>
<class-id>BeringerOrganisation.Person</class-id> <category>berechnungen</category>

<body package="organisation" selector="alterBerechnen">alterBerechnen
	"liefert das Alter der Person in Anzahl von Jahren (ohne Berücksichtigung des Monats)"

	^ (Date today year - self geburtsdatum year)</body>

<body package="organisation" selector="anrede">anrede

	(self geschlecht = MAENNLICH)
		ifTrue: [
			^ ANREDEMAENNLICH
		].

	(self geschlecht = WEIBLICH)
		ifTrue: [
			^ ANREDEWEIBLICH
		].

	^ ''</body>
</methods>

<initialize>
<variable-id>BeringerOrganisation.Person.MAENNLICH</variable-id>
</initialize>

<initialize>
<variable-id>BeringerOrganisation.Person.WEIBLICH</variable-id>
</initialize>

<initialize>
<class-id>BeringerOrganisation.Person</class-id>
</initialize>

</st-source>
